# FiniteDiff

[![Join the chat at https://julialang.zulipchat.com #sciml-bridged](https://img.shields.io/static/v1?label=Zulip&message=chat&color=9558b2&labelColor=389826)](https://julialang.zulipchat.com/#narrow/stream/279055-sciml-bridged)
[![Global Docs](https://img.shields.io/badge/docs-SciML-blue.svg)](https://docs.sciml.ai/FiniteDiff/stable/)

[![codecov](https://codecov.io/gh/JuliaDiff/FiniteDiff.jl/branch/master/graph/badge.svg)](https://app.codecov.io/gh/JuliaDiff/FiniteDiff.jl)
[![Build Status](https://github.com/JuliaDiff/FiniteDiff.jl/workflows/CI/badge.svg)](https://github.com/JuliaDiff/FiniteDiff.jl/actions?query=workflow%3ACI)

[![ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://img.shields.io/badge/ColPrac-Contributor's%20Guide-blueviolet)](https://github.com/SciML/ColPrac)
[![SciML Code Style](https://img.shields.io/static/v1?label=code%20style&message=SciML&color=9558b2&labelColor=389826)](https://github.com/SciML/SciMLStyle)

## Overview

This package is for calculating derivatives, gradients, Jacobians, Hessians,
etc. numerically. This library is for maximizing speed while giving a usable
interface to end users in a way that specializes on array types and sparsity.
Included is:

- Fully non-allocating mutable forms for fast array support
- Fully non-mutating forms for static array support
- Coloring vectors for efficient calculation of sparse Jacobians
- GPU-compatible, to the extent that you can be with finite differencing.

If you want the fastest versions, create a cache and repeatedly call the
differencing functions at different `x` values (or with different `f` functions),
while if you want a quick and dirty numerical answer, directly call a differencing
function.

**For analogous sparse differentiation with automatic differentiation, see [SparseDiffTools.jl](https://github.com/JuliaDiff/SparseDiffTools.jl).**

### FiniteDiff.jl vs FiniteDifferences.jl

[FiniteDiff.jl](https://github.com/JuliaDiff/FiniteDiff.jl) and [FiniteDifferences.jl](https://github.com/JuliaDiff/FiniteDifferences.jl)
are similar libraries: both calculate approximate derivatives numerically.
You should definitely use one or the other, rather than the legacy [Calculus.jl](https://github.com/JuliaMath/Calculus.jl) finite differencing, or reimplementing it yourself.
At some point in the future they might merge, or one might depend on the other.
Right now here are the differences:

 - FiniteDifferences.jl supports basically any type, where as FiniteDiff.jl supports only array-ish types
 - FiniteDifferences.jl supports higher order approximation
 - FiniteDiff.jl is carefully optimized to minimize allocations
 - FiniteDiff.jl supports coloring vectors for efficient calculation of sparse Jacobians

## General structure

The general structure of the library is as follows. You can call the differencing
functions directly and this will allocate a temporary cache to solve the problem
with. To make this non-allocating for repeat calls, you can call the cache
construction functions. Each cache construction function has two possibilities:
one version where you give it prototype arrays and it generates the cache
variables, and one fully non-allocating version where you give it the cache
variables. This is summarized as:

- Just want a quick derivative? Calculating once? Call the differencing function.
- Going to calculate the derivative multiple times but don't have cache arrays
  around? Use the allocating cache and then pass this into the differencing
  function (this will allocate only in the one cache construction).
- Have cache variables around from your own algorithm and want to re-use them
  in the differencing functions? Use the non-allocating cache construction
  and pass the cache to the differencing function.

See the [documentation](https://docs.sciml.ai/FiniteDiff/stable/) for details on the API.

### Function definitions

In all functions, the inplace form is `f!(dx,x)` while the out of place form is `dx = f(x)`.

### Coloring vectors

Coloring vectors are allowed to be supplied to the Jacobian routines, and these are
the directional derivatives for constructing the Jacobian. For example, an accurate
NxN tridiagonal Jacobian can be computed in just 4 `f` calls by using
`colorvec=repeat(1:3,N÷3)`. For information on automatically generating coloring
vectors of sparse matrices, see [SparseMatrixColorings.jl](https://github.com/gdalle/SparseMatrixColorings.jl) and 
the now deprecated [SparseDiffTools.jl](https://github.com/JuliaDiff/SparseDiffTools.jl).

## Contributing

- Please refer to the
  [SciML ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://github.com/SciML/ColPrac/blob/master/README.md)
  for guidance on PRs, issues, and other matters relating to contributing to SciML.
- See the [SciML Style Guide](https://github.com/SciML/SciMLStyle) for common coding practices and other style decisions.
- There are a few community forums:
  - The #diffeq-bridged and #sciml-bridged channels in the
    [Julia Slack](https://julialang.org/slack/)
  - The #diffeq-bridged and #sciml-bridged channels in the
    [Julia Zulip](https://julialang.zulipchat.com/#narrow/stream/279055-sciml-bridged)
  - On the [Julia Discourse forums](https://discourse.julialang.org)
  - See also [SciML Community page](https://sciml.ai/community/)

"""
    JVPCache{X1, FX1, FDType}

Cache structure for Jacobian-vector product (JVP) computations.

Stores temporary arrays needed for efficient JVP computation without repeated allocations.
The JVP computes `J(x) * v` where `J(x)` is the Jacobian of function `f` at point `x` 
and `v` is a vector.

# Fields
- `x1::X1`: Temporary array for perturbed input values
- `fx1::FX1`: Temporary array for function evaluations
"""
struct JVPCache{X1, FX1, FDType}
    x1::X1
    fx1::FX1
end

"""
    FiniteDiff.JVPCache(x, fdtype::Type{T1} = Val{:forward})

Allocating cache constructor for Jacobian-vector product computations.

Creates a `JVPCache` by allocating temporary arrays with the same structure as `x`.
This constructor is convenient but allocates memory for the cache arrays.

# Arguments
- `x`: Input vector whose structure determines the cache array sizes
- `fdtype::Type{T1} = Val{:forward}`: Finite difference method type

# Returns
- `JVPCache` with allocated temporary arrays for JVP computation

# Examples
```julia
x = [1.0, 2.0, 3.0]
cache = JVPCache(x, Val(:forward))
```
"""
function JVPCache(
        x,
        fdtype::Union{Val{FD}, Type{FD}} = Val(:forward)) where {FD}
    fdtype isa Type && (fdtype = fdtype())
    JVPCache{typeof(x), typeof(x), fdtype}(copy(x), copy(x))
end

"""
    FiniteDiff.JVPCache(x, fx1, fdtype::Type{T1} = Val{:forward})

Non-allocating cache constructor for Jacobian-vector product computations.

Creates a `JVPCache` using pre-allocated arrays `x` and `fx1`. This constructor
is memory-efficient as it reuses existing arrays without additional allocation.

# Arguments
- `x`: Pre-allocated array for perturbed input values
- `fx1`: Pre-allocated array for function evaluations
- `fdtype::Type{T1} = Val{:forward}`: Finite difference method type

# Returns
- `JVPCache` using the provided arrays as cache storage

# Examples
```julia
x = [1.0, 2.0, 3.0]
fx1 = similar(x)
cache = JVPCache(x, fx1, Val(:forward))
```

# Notes
The arrays `x` and `fx1` will be modified during JVP computations. Ensure they
are not used elsewhere if their values need to be preserved.
"""
function JVPCache(
        x,
        fx,
        fdtype::Union{Val{FD}, Type{FD}} = Val(:forward)) where {FD}
    fdtype isa Type && (fdtype = fdtype())
    JVPCache{typeof(x), typeof(fx), fdtype}(x, fx)
end

"""
    FiniteDiff.finite_difference_jvp(
        f,
        x      :: AbstractArray{<:Number},
        v      :: AbstractArray{<:Number},
        fdtype :: Type{T1}                = Val{:forward},
        f_in                              = nothing;
        relstep = default_relstep(fdtype, eltype(x)),
        absstep = relstep)

Compute the Jacobian-vector product `J(x) * v` using finite differences.

This function computes the directional derivative of `f` at `x` in direction `v`
without explicitly forming the Jacobian matrix. This is more efficient than
computing the full Jacobian when only `J*v` is needed.

# Arguments
- `f`: Function to differentiate (vector→vector map)
- `x::AbstractArray{<:Number}`: Point at which to evaluate the Jacobian
- `v::AbstractArray{<:Number}`: Direction vector for the product
- `fdtype::Type{T1}=Val{:forward}`: Finite difference method (`:forward`, `:central`)
- `f_in=nothing`: Pre-computed `f(x)` value (if available)

# Keyword Arguments
- `relstep`: Relative step size (default: method-dependent optimal value)
- `absstep=relstep`: Absolute step size fallback

# Returns
- Vector `J(x) * v` representing the Jacobian-vector product

# Examples
```julia
f(x) = [x[1]^2 + x[2], x[1] * x[2], x[2]^3]
x = [1.0, 2.0]
v = [1.0, 0.0]  # Direction vector
jvp = finite_difference_jvp(f, x, v)  # Directional derivative
```

# Mathematical Background
The JVP is computed using the finite difference approximation:
- Forward: `J(x) * v ≈ (f(x + h*v) - f(x)) / h`
- Central: `J(x) * v ≈ (f(x + h*v) - f(x - h*v)) / (2h)`

where `h` is the step size and `v` is the direction vector.

# Notes
- Requires only `2` function evaluations (vs `O(n)` for full Jacobian)
- Forward differences: 2 function evaluations, `O(h)` accuracy
- Central differences: 2 function evaluations, `O(h²)` accuracy
- Particularly efficient when `v` is sparse or when only one directional derivative is needed
"""
function finite_difference_jvp(f, x, v,
        fdtype = Val(:forward),
        f_in = nothing;
        relstep = default_relstep(fdtype, eltype(x)),
        absstep = relstep,
        dir = true)
    if f_in isa Nothing
        fx = f(x)
    else
        fx = f_in
    end
    cache = JVPCache(x, fx, fdtype)
    finite_difference_jvp(f, x, v, cache, fx; relstep, absstep, dir)
end

"""
    FiniteDiff.finite_difference_jvp(
        f,
        x,
        v,
        cache::JVPCache;
        relstep = default_relstep(fdtype, eltype(x)),
        absstep = relstep)

Cached.
"""
function finite_difference_jvp(
        f,
        x,
        v,
        cache::JVPCache{X1, FX1, fdtype},
        f_in = nothing;
        relstep = default_relstep(fdtype, eltype(x)),
        absstep = relstep,
        dir = true) where {X1, FX1, fdtype}
    if fdtype == Val(:complex)
        ArgumentError("finite_difference_jvp doesn't support :complex-mode finite diff")
    end

    tmp = sqrt(abs(dot(_vec(x), _vec(v))))
    epsilon = compute_epsilon(fdtype, tmp, relstep, absstep, dir)
    if fdtype == Val(:forward)
        fx = f_in isa Nothing ? f(x) : f_in
        x1 = @. x + epsilon * v
        fx1 = f(x1)
        fx1 = @. (fx1-fx)/epsilon
    elseif fdtype == Val(:central)
        x1 = @. x + epsilon * v
        fx1 = f(x1)
        x1 = @. x - epsilon * v
        fx = f(x1)
        fx1 = @. (fx1-fx)/(2epsilon)
    else
        fdtype_error(eltype(x))
    end
    fx1
end

"""
    finite_difference_jvp!(
        jvp        :: AbstractArray{<:Number},
        f,
        x          :: AbstractArray{<:Number},
        v          :: AbstractArray{<:Number},
        fdtype     :: Type{T1}          = Val{:forward},
        returntype :: Type{T2}          = eltype(x),
        f_in       :: Union{T2,Nothing} = nothing;
        relstep = default_relstep(fdtype, eltype(x)),
        absstep = relstep)

Cache-less.
"""
function finite_difference_jvp!(jvp,
        f,
        x,
        v,
        fdtype = Val(:forward),
        f_in = nothing;
        relstep = default_relstep(fdtype, eltype(x)),
        absstep = relstep)
    if !isnothing(f_in)
        cache = JVPCache(x, f_in, fdtype)
    elseif fdtype == Val(:forward)
        fx = zero(x)
        f(fx, x)
        cache = JVPCache(x, fx, fdtype)
    else
        cache = JVPCache(x, fdtype)
    end
    finite_difference_jvp!(jvp, f, x, v, cache, cache.fx1; relstep, absstep)
end

"""
    FiniteDiff.finite_difference_jvp!(
        jvp   :: AbstractArray{<:Number},
        f,
        x     :: AbstractArray{<:Number},
        v     :: AbstractArray{<:Number},
        cache :: JVPCache;
        relstep = default_relstep(fdtype, eltype(x)),
        absstep = relstep,
        dir     = true)

Cached.
"""
function finite_difference_jvp!(
        jvp,
        f,
        x,
        v,
        cache::JVPCache{X1, FX1, fdtype},
        f_in = nothing;
        relstep = default_relstep(fdtype, eltype(x)),
        absstep = relstep,
        dir = true) where {X1, FX1, fdtype}
    if fdtype == Val(:complex)
        ArgumentError("finite_difference_jvp doesn't support :complex-mode finite diff")
    end

    (; x1, fx1) = cache
    tmp = sqrt(abs(dot(_vec(x), _vec(v))))
    epsilon = compute_epsilon(fdtype, tmp, relstep, absstep, dir)
    if fdtype == Val(:forward)
        if f_in isa Nothing
            f(fx1, x)
        else
            fx1 = f_in
        end
        @. x1 = x + epsilon * v
        f(jvp, x1)
        @. jvp = (jvp-fx1)/epsilon
    elseif fdtype == Val(:central)
        @. x1 = x - epsilon * v
        f(fx1, x1)
        @. x1 = x + epsilon * v
        f(jvp, x1)
        @. jvp = (jvp-fx1)/(2epsilon)
    else
        fdtype_error(eltype(x))
    end
    nothing
end

function resize!(cache::JVPCache, i::Int)
    resize!(cache.x1, i)
    cache.fx1 !== nothing && resize!(cache.fx1, i)
    nothing
end

module FiniteDiffStaticArraysExt

if isdefined(Base, :get_extension)
    using FiniteDiff: FiniteDiff, ArrayInterface
    using StaticArrays
else
    using ..FiniteDiff: FiniteDiff, ArrayInterface
    using ..StaticArrays
end
FiniteDiff._mat(x::StaticVector)   = reshape(x, (axes(x, 1),     SOneTo(1)))
FiniteDiff.setindex(x::StaticArray, v, i::Int...) = StaticArrays.setindex(x, v, i...)
FiniteDiff.__Symmetric(x::SMatrix) = Symmetric(SArray(H))

end #module

"""
    FiniteDiff.finite_difference_derivative(
        f,
        x          :: T,
        fdtype     :: Type{T1}         = Val{:central},
        returntype :: Type{T2}         = eltype(x),
        f_x        :: Union{Nothing,T} = nothing)

Single-point derivative of scalar->scalar maps.
"""
function finite_difference_derivative(
    f,
    x::T,
    fdtype=Val(:central),
    returntype=eltype(x),
    f_x=nothing;
    relstep=default_relstep(fdtype, T),
    absstep=relstep,
    dir=true) where {T<:Number}

    fdtype isa Type && (fdtype = fdtype())
    epsilon = compute_epsilon(fdtype, x, relstep, absstep, dir)
    if fdtype==Val(:forward)
        return (f(x+epsilon) - f(x)) / epsilon
    elseif fdtype==Val(:central)
        return (f(x+epsilon) - f(x-epsilon)) / (2*epsilon)
    elseif fdtype==Val(:complex) && returntype<:Real
        return imag(f(x+im*epsilon)) / epsilon
    end
    fdtype_error(returntype)
end
# Single point derivative implementations end here.


#=
Multi-point implementations of scalar derivatives for efficiency.
=#
struct DerivativeCache{CacheType1, CacheType2, fdtype, returntype}
    fx      :: CacheType1
    epsilon :: CacheType2
end

"""
    FiniteDiff.DerivativeCache(
        x          :: AbstractArray{<:Number},
        fx         :: Union{Nothing,AbstractArray{<:Number}} = nothing,
        epsilon    :: Union{Nothing,AbstractArray{<:Real}}   = nothing,
        fdtype     :: Type{T1} = Val{:central},
        returntype :: Type{T2} = eltype(x))

This allocates either `fx` or `epsilon` if these are nothing and they are needed.
`fx` is the current call of `f(x)` and is required for forward-differencing
(otherwise is not necessary).
"""
function DerivativeCache(
    x          :: AbstractArray{<:Number},
    fx         :: Union{Nothing,AbstractArray{<:Number}} = nothing,
    epsilon    :: Union{Nothing,AbstractArray{<:Real}} = nothing,
    fdtype     :: Type{T1} = Val(:central),
    returntype :: Type{T2} = eltype(x)) where {T1,T2}

    fdtype isa Type && (fdtype = fdtype())
    if fdtype==Val(:complex) && !(eltype(returntype)<:Real)
        fdtype_error(returntype)
    end

    if fdtype!=Val(:forward) && typeof(fx)!=Nothing
        @warn("Pre-computed function values are only useful for fdtype==Val(:forward).")
        _fx = nothing
    else
        # more runtime sanity checks?
        _fx = fx
    end

    if typeof(epsilon)!=Nothing && typeof(x)<:StridedArray && typeof(fx)<:Union{Nothing,StridedArray} && 1==2
        @warn("StridedArrays don't benefit from pre-allocating epsilon.")
        _epsilon = nothing
    elseif typeof(epsilon)!=Nothing && fdtype==Val(:complex)
        @warn("Val(:complex) makes the epsilon array redundant.")
        _epsilon = nothing
    else
        if typeof(epsilon)==Nothing || eltype(epsilon)!=real(eltype(x))
          epsilon = fill(zero(real(eltype(x))), size(x))
        end
        _epsilon = epsilon
    end
    DerivativeCache{typeof(_fx),typeof(_epsilon),fdtype,returntype}(_fx,_epsilon)
end

"""
    FiniteDiff.finite_difference_derivative(
        f,
        x          :: AbstractArray{<:Number},
        fdtype     :: Type{T1} = Val{:central},
        returntype :: Type{T2} = eltype(x),      # return type of f
        fx         :: Union{Nothing,AbstractArray{<:Number}} = nothing,
        epsilon    :: Union{Nothing,AbstractArray{<:Real}} = nothing;
        [epsilon_factor])

Compute the derivative `df` of a scalar-valued map `f` at a collection of points `x`.

Cache-less.
"""
function finite_difference_derivative(
    f,
    x,
    fdtype = Val(:central),
    returntype = eltype(x),      # return type of f
    fx = nothing,
    epsilon = nothing;
    relstep=default_relstep(fdtype, eltype(x)),
    absstep=relstep)

    df = fill(zero(returntype), size(x))
    finite_difference_derivative!(df, f, x, fdtype, returntype, fx, epsilon; relstep=relstep, absstep=absstep)
end

"""
    FiniteDiff.finite_difference_derivative!(
        df         :: AbstractArray{<:Number},
        f,
        x          :: AbstractArray{<:Number},
        fdtype     :: Type{T1} = Val{:central},
        returntype :: Type{T2} = eltype(x),
        fx         :: Union{Nothing,AbstractArray{<:Number}} = nothing,
        epsilon    :: Union{Nothing,AbstractArray{<:Real}}   = nothing;
        [epsilon_factor])

Compute the derivative `df` of a scalar-valued map `f` at a collection of points `x`.

Cache-less but non-allocating if `fx` and `epsilon` are supplied (`fx` must be `f(x)`).
"""
function finite_difference_derivative!(
    df,
    f,
    x,
    fdtype = Val(:central),
    returntype = eltype(x),
    fx = nothing,
    epsilon = nothing;
    relstep=default_relstep(fdtype, eltype(x)),
    absstep=relstep)

    cache = DerivativeCache(x, fx, epsilon, fdtype, returntype)
    finite_difference_derivative!(df, f, x, cache; relstep=relstep, absstep=absstep)
end

"""
    FiniteDiff.finite_difference_derivative!(
        df    :: AbstractArray{<:Number},
        f,
        x     :: AbstractArray{<:Number},
        cache :: DerivativeCache{T1,T2,fdtype,returntype};
        relstep = default_relstep(fdtype, eltype(x)),
        absstep = relstep,
        dir     = true)

Compute the derivative `df` of a scalar-valued map `f` at a collection of points `x`.

Cached.
"""
function finite_difference_derivative!(
    df,
    f,
    x,
    cache::DerivativeCache{T1,T2,fdtype,returntype};
    relstep=default_relstep(fdtype, eltype(x)),
    absstep=relstep,
    dir=true) where {T1,T2,fdtype,returntype}

    fx, epsilon = cache.fx, cache.epsilon
    if typeof(epsilon) != Nothing
        @. epsilon = compute_epsilon(fdtype, x, relstep, absstep, dir)
    end
    if fdtype == Val(:forward)
        if typeof(fx) == Nothing
            @. df = (f(x+epsilon) - f(x)) / epsilon
        else
            @. df = (f(x+epsilon) - fx) / epsilon
        end
    elseif fdtype == Val(:central)
        @. df = (f(x+epsilon) - f(x-epsilon)) / (2 * epsilon)
    elseif fdtype == Val(:complex) && returntype<:Real
        epsilon_complex = eps(eltype(x))
        @. df = imag(f(x+im*epsilon_complex)) / epsilon_complex
    else
        fdtype_error(returntype)
    end
    df
end

#=
Optimized implementations for StridedArrays.
Essentially, the only difference between these and the AbstractArray case
is that here we can compute the epsilon one by one in local variables and avoid caching it.
=#
function finite_difference_derivative!(
    df::StridedArray,
    f,
    x::StridedArray,
    cache::DerivativeCache{T1,T2,fdtype,returntype};
    relstep=default_relstep(fdtype, eltype(x)),
    absstep=relstep,
    dir=true) where {T1,T2,fdtype,returntype}

    if fdtype == Val(:forward)
        fx = cache.fx
        @inbounds for i ∈ eachindex(x)
            epsilon = compute_epsilon(Val(:forward), x[i], relstep, absstep, dir)
            x_plus = x[i] + epsilon
            if typeof(fx) == Nothing
                df[i] = (f(x_plus) - f(x[i])) / epsilon
            else
                df[i] = (f(x_plus) - fx[i]) / epsilon
            end
        end
    elseif fdtype == Val(:central)
        @inbounds for i ∈ eachindex(x)
            epsilon = compute_epsilon(Val(:central), x[i], relstep, absstep, dir)
            epsilon_double_inv = one(typeof(epsilon)) / (2*epsilon)
            x_plus, x_minus = x[i]+epsilon, x[i]-epsilon
            df[i] = (f(x_plus) - f(x_minus)) * epsilon_double_inv
        end
    elseif fdtype == Val(:complex)
        epsilon_complex = eps(eltype(x))
        @inbounds for i ∈ eachindex(x)
            df[i] = imag(f(x[i]+im*epsilon_complex)) / epsilon_complex
        end
    else
        fdtype_error(returntype)
    end
    df
end

using FiniteDiff, LinearAlgebra, Test

# f_i(x) = x_i * x_{i+1} (cyclic): smooth, varies on the scale of x, and has an
# exactly known Jacobian, so the reference J*v carries no discretization error.
const N_JVP = 200
nxt(i) = i == N_JVP ? 1 : i + 1
fcyc(x) = [x[i] * x[nxt(i)] for i in eachindex(x)]
fcyc!(y, x) = (for i in eachindex(x)
        y[i] = x[i] * x[nxt(i)]
    end; y)
Jv_exact(x, v) = [x[nxt(i)] * v[i] + x[i] * v[nxt(i)] for i in eachindex(x)]

relerr(a, b) = norm(a - b) / norm(b)

x_big = [100.0 * (1 + i / N_JVP) for i in 1:N_JVP]
v_unit = [sin(float(i)) for i in 1:N_JVP]
v_unit ./= norm(v_unit)
ref_big = Jv_exact(x_big, v_unit)

@testset "JVP step size and accuracy" begin
    @testset "JVP step size scales with norm(x)" begin
        @test relerr(FiniteDiff.finite_difference_jvp(fcyc, copy(x_big), v_unit), ref_big) < 1e-7
        jvp = similar(x_big)
        FiniteDiff.finite_difference_jvp!(jvp, fcyc!, copy(x_big), v_unit)
        @test relerr(jvp, ref_big) < 1e-7

        @test relerr(FiniteDiff.finite_difference_jvp(fcyc, copy(x_big), v_unit, Val{:central}),
            ref_big) < 1e-10
        FiniteDiff.finite_difference_jvp!(jvp, fcyc!, copy(x_big), v_unit, Val{:central})
        @test relerr(jvp, ref_big) < 1e-10
    end

    @testset "JVP is invariant to the scaling of v" begin
        base = FiniteDiff.finite_difference_jvp(fcyc, copy(x_big), v_unit)
        for s in (1.0e-4, 1.0e2, 1.0e4)
            scaled = FiniteDiff.finite_difference_jvp(fcyc, copy(x_big), s .* v_unit) ./ s
            @test relerr(scaled, base) < 1e-8
            @test relerr(scaled, ref_big) < 1e-7
        end
    end

    @testset "JVP degenerate directions and states" begin
        zerojvp = FiniteDiff.finite_difference_jvp(fcyc, copy(x_big), zero(v_unit))
        @test all(isfinite, zerojvp)
        @test iszero(zerojvp)

        # norm(x) == 0 must fall back to the absstep floor rather than a zero step
        zerox = zeros(N_JVP)
        atzero = FiniteDiff.finite_difference_jvp(fcyc, zerox, v_unit)
        @test all(isfinite, atzero)
        @test norm(atzero) < 1e-6

        # a non-finite entry of x must not contaminate the step, and hence every output
        nanx = copy(x_big)
        nanx[1] = NaN
        nanjvp = FiniteDiff.finite_difference_jvp(fcyc, nanx, v_unit)
        @test count(isnan, nanjvp) == 2
    end

    @testset "JVP complex-valued state" begin
        xc = [(1 + im) * 100.0 * (1 + i / N_JVP) for i in 1:N_JVP]
        vc = v_unit .+ im .* reverse(v_unit)
        vc ./= norm(vc)
        refc = Jv_exact(xc, vc)
        @test relerr(FiniteDiff.finite_difference_jvp(fcyc, copy(xc), vc), refc) < 1e-7
        jvpc = similar(xc)
        FiniteDiff.finite_difference_jvp!(jvpc, fcyc!, copy(xc), vc)
        @test relerr(jvpc, refc) < 1e-7
    end
end

# Put in a separate page so it can be used by SciMLDocs.jl

pages = [
    "Home" => "index.md",
    "Tutorials" => "tutorials.md",
    "Derivatives" => "derivatives.md",
    "Gradients" => "gradients.md", 
    "Jacobians" => "jacobians.md",
    "Hessians" => "hessians.md",
    "Jacobian-Vector Products" => "jvp.md",
    "Step Size Selection" => "epsilons.md",
    "Internal Utilities" => "utilities.md"
]

#=
Very heavily inspired by Calculus.jl, but with an emphasis on performance and DiffEq API convenience.
=#

"""
    compute_epsilon(::Val{:forward}, x::T, relstep::Real, absstep::Real, dir::Real) where T<:Number

Compute the finite difference step size (epsilon) for forward finite differences.

The step size is computed as `max(relstep*abs(x), absstep)*dir`, which ensures 
numerical stability by using a relative step scaled by the magnitude of `x` 
when `x` is large, and an absolute step when `x` is small.

# Arguments
- `::Val{:forward}`: Finite difference type indicator for forward differences
- `x::T`: Point at which to compute the step size
- `relstep::Real`: Relative step size factor
- `absstep::Real`: Absolute step size fallback
- `dir::Real`: Direction multiplier (typically ±1)

# Returns
- Step size `ϵ` for forward finite difference: `f(x + ϵ)`

Reference: Numerical Recipes, chapter 5.7.
"""
@inline function compute_epsilon(
        ::Val{:forward}, x::T, relstep::Real, absstep::Real, dir::Real) where {T <: Number}
    return max(relstep*abs(x), absstep)*dir
end

"""
    compute_epsilon(::Val{:central}, x::T, relstep::Real, absstep::Real, dir=nothing) where T<:Number

Compute the finite difference step size (epsilon) for central finite differences.

The step size is computed as `max(relstep*abs(x), absstep)`, which ensures 
numerical stability by using a relative step scaled by the magnitude of `x` 
when `x` is large, and an absolute step when `x` is small.

# Arguments
- `::Val{:central}`: Finite difference type indicator for central differences
- `x::T`: Point at which to compute the step size
- `relstep::Real`: Relative step size factor
- `absstep::Real`: Absolute step size fallback
- `dir`: Direction parameter (unused for central differences)

# Returns
- Step size `ϵ` for central finite difference: `(f(x + ϵ) - f(x - ϵ)) / (2ϵ)`
"""
@inline function compute_epsilon(::Val{:central}, x::T, relstep::Real,
        absstep::Real, dir = nothing) where {T <: Number}
    return max(relstep*abs(x), absstep)
end

"""
    compute_epsilon(::Val{:hcentral}, x::T, relstep::Real, absstep::Real, dir=nothing) where T<:Number

Compute the finite difference step size (epsilon) for central finite differences in Hessian computations.

The step size is computed as `max(relstep*abs(x), absstep)`, which ensures 
numerical stability by using a relative step scaled by the magnitude of `x` 
when `x` is large, and an absolute step when `x` is small.

# Arguments
- `::Val{:hcentral}`: Finite difference type indicator for Hessian central differences
- `x::T`: Point at which to compute the step size
- `relstep::Real`: Relative step size factor
- `absstep::Real`: Absolute step size fallback
- `dir`: Direction parameter (unused for central differences)

# Returns
- Step size `ϵ` for Hessian central finite differences
"""
@inline function compute_epsilon(::Val{:hcentral}, x::T, relstep::Real,
        absstep::Real, dir = nothing) where {T <: Number}
    return max(relstep*abs(x), absstep)
end

"""
    compute_epsilon(::Val{:complex}, x::T, ::Union{Nothing,T}=nothing, ::Union{Nothing,T}=nothing, dir=nothing) where T<:Real

Compute the finite difference step size (epsilon) for complex step differentiation.

For complex step differentiation, the step size is simply the machine epsilon `eps(T)`,
which provides optimal accuracy since complex step differentiation doesn't suffer from
subtractive cancellation errors.

!!! warn

   `f` must be a function of a real variable which also happens to be complex analytic when the input is complex!

# Arguments
- `::Val{:complex}`: Finite difference type indicator for complex step differentiation
- `x::T`: Point at which to compute the step size (unused, type determines epsilon)
- Additional arguments are unused for complex step differentiation

# Returns
- Machine epsilon `eps(T)` for complex step differentiation: `imag(f(x + iϵ)) / ϵ`

# Notes
Complex step differentiation computes derivatives as `imag(f(x + iϵ)) / ϵ` where `ϵ = eps(T)`.
This method provides machine precision accuracy without subtractive cancellation.
"""
@inline function compute_epsilon(::Val{:complex}, x::T, ::Union{Nothing, T} = nothing,
        ::Union{Nothing, T} = nothing, dir = nothing) where {T <: Real}
    return eps(T)
end

"""
    default_relstep(fdtype, ::Type{T}) where T<:Number

Compute the default relative step size for finite difference approximations.

Returns optimal default step sizes based on the finite difference method and 
numerical type, balancing truncation error and round-off error.

# Arguments
- `fdtype`: Finite difference type (`Val(:forward)`, `Val(:central)`, `Val(:hcentral)`, etc.)
- `::Type{T}`: Numerical type for which to compute the step size

# Returns
- `sqrt(eps(real(T)))` for forward differences
- `cbrt(eps(real(T)))` for central differences  
- `eps(T)^(1/4)` for Hessian central differences
- `one(real(T))` for other types

# Notes
These step sizes minimize the total error (truncation + round-off) for each method:
- Forward differences have O(h) truncation error, optimal h ~ sqrt(eps)
- Central differences have O(h²) truncation error, optimal h ~ eps^(1/3)
- Hessian methods have O(h²) truncation error but involve more operations
"""
default_relstep(::Type{V}, T) where {V} = default_relstep(V(), T)
@inline function default_relstep(::Val{fdtype}, ::Type{T}) where {fdtype, T <: Number}
    if fdtype==:forward
        return sqrt(eps(real(T)))
    elseif fdtype==:central
        return cbrt(eps(real(T)))
    elseif fdtype==:hcentral
        eps(T)^(1/4)
    else
        return one(real(T))
    end
end

"""
    fdtype_error(::Type{T}=Float64) where T

Throw an informative error for unsupported finite difference type combinations.

# Arguments
- `::Type{T}`: Return type of the function being differentiated

# Errors
- For `Real` return types: suggests `Val{:forward}`, `Val{:central}`, `Val{:complex}`
- For `Complex` return types: suggests `Val{:forward}`, `Val{:central}` (no complex step)
- For other types: suggests the return type should be Real or Complex subtype
"""
function fdtype_error(::Type{T} = Float64) where {T}
    if T<:Real
        error("Unrecognized fdtype: valid values are Val{:forward}, Val{:central} and Val{:complex}.")
    elseif T<:Complex
        error("Unrecognized fdtype: valid values are Val{:forward} or Val{:central}.")
    else
        error("Unrecognized returntype: should be a subtype of Real or Complex.")
    end
end

mutable struct JacobianCache{CacheType1, CacheType2, CacheType3, CacheType4,
    ColorType, SparsityType, fdtype, returntype}
    x1::CacheType1
    x2::CacheType2
    fx::CacheType3
    fx1::CacheType4
    colorvec::ColorType
    sparsity::SparsityType
end

function JacobianCache(
        x,
        fdtype::Union{Val{T1}, Type{T1}} = Val(:forward),
        returntype::Type{T2} = eltype(x);
        inplace::Union{Val{T3}, Type{T3}} = Val(true),
        colorvec = 1:length(x),
        sparsity = nothing) where {T1, T2, T3}
    fdtype isa Type && (fdtype = fdtype())
    inplace isa Type && (inplace = inplace())
    if eltype(x) <: Real && fdtype==Val(:complex)
        x1 = false .* im .* x
        _fx = false .* im .* x
    else
        x1 = copy(x)
        _fx = copy(x)
    end

    if fdtype==Val(:complex)
        _fx1 = nothing
    else
        _fx1 = copy(x)
    end

    JacobianCache(
        x1, _fx, _fx1, fdtype, returntype; colorvec = colorvec, sparsity = sparsity)
end

"""
    FiniteDiff.JacobianCache(
        x,
        fdtype     :: Type{T1} = Val{:central},
        returntype :: Type{T2} = eltype(x),
        colorvec = 1:length(x)
        sparsity = nothing)

Allocating Cache Constructor.

This assumes the Jacobian is square.
"""
function JacobianCache(
        x,
        fx,
        fdtype::Union{Val{T1}, Type{T1}} = Val(:forward),
        returntype::Type{T2} = eltype(x);
        inplace::Union{Val{T3}, Type{T3}} = Val(true),
        colorvec = 1:length(x),
        sparsity = nothing) where {T1, T2, T3}
    fdtype isa Type && (fdtype = fdtype())
    inplace isa Type && (inplace = inplace())
    if eltype(x) <: Real && fdtype==Val(:complex)
        x1 = false .* im .* x
    else
        x1 = copy(x)
    end

    if eltype(fx) <: Real && fdtype==Val(:complex)
        _fx = false .* im .* fx
    else
        _fx = copy(fx)
    end

    if fdtype==Val(:complex)
        _fx1 = nothing
    else
        _fx1 = copy(fx)
    end

    JacobianCache(
        x1, _fx, _fx1, fdtype, returntype; colorvec = colorvec, sparsity = sparsity)
end

"""
    FiniteDiff.JacobianCache(
        x1,
        fx,
        fx1,
        fdtype     :: Type{T1} = Val{:central},
        returntype :: Type{T2} = eltype(fx);
        colorvec = 1:length(x1),
        sparsity = nothing)

Non-Allocating Cache Constructor.
"""
function JacobianCache(
        x1,
        fx,
        fx1,
        fdtype::Union{Val{T1}, Type{T1}} = Val(:forward),
        returntype::Type{T2} = eltype(fx);
        inplace::Union{Val{T3}, Type{T3}} = Val(true),
        colorvec = 1:length(x1),
        sparsity = nothing) where {T1, T2, T3}
    fdtype isa Type && (fdtype = fdtype())
    inplace isa Type && (inplace = inplace())
    if fdtype==Val(:complex)
        !(returntype<:Real) && fdtype_error(returntype)

        if eltype(fx) <: Real
            _fx = false .* im .* fx
        else
            _fx = fx
        end
        if eltype(x1) <: Real
            _x1 = false .* im .* x1
        else
            _x1 = x1
        end
    else
        _x1 = x1
        @assert eltype(fx) == T2
        @assert eltype(fx1) == T2
        _fx = fx
    end
    _x2 = zero(_x1)
    JacobianCache{typeof(_x1), typeof(_x2), typeof(_fx), typeof(fx1),
        typeof(colorvec), typeof(sparsity), fdtype, returntype}(
        _x1, _x2, _fx, fx1, colorvec, sparsity)
end

"""
    _make_Ji(::AbstractArray, rows_index, cols_index, dx, colorvec, color_i, nrows, ncols)

Internal function to construct the Jacobian contribution matrix for sparse Jacobian computation.

Creates a matrix `Ji` that represents the contribution of the `color_i` color group 
to the Jacobian. This is used in graph-coloring based sparse Jacobian computation.

# Arguments
- `::AbstractArray`: Array type dispatch
- `rows_index`: Row indices of non-zero elements
- `cols_index`: Column indices of non-zero elements  
- `dx`: Computed finite difference values
- `colorvec`: Vector assigning colors to columns
- `color_i`: Current color being processed
- `nrows`: Number of rows in the Jacobian
- `ncols`: Number of columns in the Jacobian

# Returns
- `Ji`: Matrix containing the Jacobian entries for the current color
"""
function _make_Ji(
        ::AbstractArray, rows_index, cols_index, dx, colorvec, color_i, nrows, ncols)
    pick_inds = [i for i in 1:length(rows_index) if colorvec[cols_index[i]] == color_i]
    rows_index_c = rows_index[pick_inds]
    cols_index_c = cols_index[pick_inds]
    len_rows = length(pick_inds)
    unused_rows = setdiff(1:nrows, rows_index_c)
    perm_rows = sortperm(vcat(rows_index_c, unused_rows))
    cols_index_c = vcat(cols_index_c, zeros(Int, nrows-len_rows))[perm_rows]
    Ji = [j==cols_index_c[i] ? dx[i] : false for i in 1:nrows, j in 1:ncols]
    Ji
end

"""
    _make_Ji(::AbstractArray, xtype, dx, color_i, nrows, ncols)

Internal function to construct the Jacobian contribution matrix for dense Jacobian computation.

Creates a matrix `Ji` by placing the finite difference vector `dx` in the column 
corresponding to `color_i`, with zeros elsewhere. This is used for dense Jacobian
computation without sparsity structure.

# Arguments
- `::AbstractArray`: Array type dispatch
- `xtype`: Type of the input vector (for type stability)
- `dx`: Computed finite difference values
- `color_i`: Current color/column being processed
- `nrows`: Number of rows in the Jacobian
- `ncols`: Number of columns in the Jacobian

# Returns
- `Ji`: Matrix containing the Jacobian entries for the current column
"""
function _make_Ji(::AbstractArray, xtype, dx, color_i, nrows, ncols)
    Ji = mapreduce(i -> i==color_i ? dx : zero(dx), hcat, 1:ncols)
    size(Ji) != (nrows, ncols) ? reshape(Ji, (nrows, ncols)) : Ji #branch when size(dx) == (1,) => size(Ji) == (1,) while size(J) == (1,1)
end

"""
    FiniteDiff.finite_difference_jacobian(
        f,
        x          :: AbstractArray{<:Number},
        fdtype     :: Type{T1} = Val{:forward},
        returntype :: Type{T2} = eltype(x),
        f_in                   = nothing;
        relstep       = default_relstep(fdtype, eltype(x)),
        absstep       = relstep,
        colorvec      = 1:length(x),
        sparsity      = nothing,
        jac_prototype = nothing,
        dir           = true)

Compute the Jacobian matrix of function `f` at point `x` using finite differences.

This is the cache-less version that allocates temporary arrays internally. 
The Jacobian `J[i,j] = ∂f[i]/∂x[j]` is computed using the specified finite 
difference method. Supports sparse Jacobians via graph coloring.

# Arguments
- `f`: Function to differentiate (vector→vector map)
- `x::AbstractArray{<:Number}`: Point at which to evaluate the Jacobian
- `fdtype::Type{T1}=Val{:forward}`: Finite difference method (`:forward`, `:central`, `:complex`)
- `returntype::Type{T2}=eltype(x)`: Element type of the function output
- `f_in=nothing`: Pre-computed `f(x)` value (if available)

# Keyword Arguments
- `relstep`: Relative step size (default: method-dependent optimal value)
- `absstep=relstep`: Absolute step size fallback
- `colorvec=1:length(x)`: Column coloring for sparse Jacobians  
- `sparsity=nothing`: Sparsity pattern for the Jacobian
- `jac_prototype=nothing`: Prototype matrix defining Jacobian structure
- `dir=true`: Direction for step size (typically ±1)

# Returns
- Jacobian matrix `J` where `J[i,j] = ∂f[i]/∂x[j]`

# Examples
```julia
f(x) = [x[1]^2 + x[2], x[1] * x[2]]
x = [1.0, 2.0]
J = finite_difference_jacobian(f, x)  # 2×2 matrix
```

# Notes
- Forward differences: `O(n)` function evaluations, `O(h)` accuracy
- Central differences: `O(2n)` function evaluations, `O(h²)` accuracy  
- Complex step: `O(n)` function evaluations, machine precision accuracy
- Sparse Jacobians use graph coloring to reduce function evaluations
"""
function finite_difference_jacobian(f, x,
        fdtype = Val(:forward),
        returntype = eltype(x),
        f_in = nothing;
        relstep = default_relstep(fdtype, eltype(x)),
        absstep = relstep,
        colorvec = 1:length(x),
        sparsity = nothing,
        jac_prototype = nothing,
        dir = true)
    if f_in isa Nothing
        fx = f(x)
    else
        fx = f_in
    end
    cache = JacobianCache(x, fx, fdtype, returntype)
    finite_difference_jacobian(
        f, x, cache, fx; relstep = relstep, absstep = absstep, colorvec = colorvec,
        sparsity = sparsity, jac_prototype = jac_prototype, dir = dir)
end

void_setindex!(args...) = (setindex!(args...); return)

"""
    FiniteDiff.finite_difference_jacobian(
        f,
        x,
        cache::JacobianCache;
        relstep       = default_relstep(fdtype, eltype(x)),
        absstep       = relstep,
        colorvec      = cache.colorvec,
        sparsity      = cache.sparsity,
        jac_prototype = nothing,
        dir           = true)

Cached.
"""
function finite_difference_jacobian(
        f,
        x,
        cache::JacobianCache{T1, T2, T3, T4, cType, sType, fdtype, returntype},
        f_in = nothing;
        relstep = default_relstep(fdtype, eltype(x)),
        absstep = relstep,
        colorvec = cache.colorvec,
        sparsity = cache.sparsity,
        jac_prototype = nothing,
        dir = true) where {T1, T2, T3, T4, cType, sType, fdtype, returntype}
    x1, fx, fx1 = cache.x1, cache.fx, cache.fx1

    # Issue #213: cache.x1 may have been initialized via `similar(x)` (e.g. by
    # DifferentiationInterface) or built around a previous x. Synchronize it
    # with the current x so the cache is observably consistent after the call.
    if x1 isa AbstractArray && ArrayInterface.ismutable(x1) && x1 !== x
        copyto!(x1, x)
    end

    # Single assignment site: `vecfx` is captured by the `calculate_Ji_*` closures
    # below, and a captured variable with several assignment sites is boxed, which
    # makes the whole function's return type uninferrable.
    vecfx = if !(f_in isa Nothing)
        _vec(f_in)
    elseif fdtype == Val(:forward)
        _vec(f(x))
    elseif fdtype == Val(:complex) && returntype <: Real
        real(fx)
    else
        _vec(fx)
    end
    vecx = _vec(x)
    J = jac_prototype isa Nothing ?
        (sparsity isa Nothing ? Array{eltype(x), 2}(undef, length(vecfx), 0) :
         zeros(eltype(x), size(sparsity))) : zero(jac_prototype)
    nrows, ncols = size(J)

    if !(sparsity isa Nothing)
        structural_rows, structural_cols = ArrayInterface.findstructralnz(sparsity)
        rows_index = [structural_rows[i] for i in 1:length(structural_rows)]
        cols_index = [structural_cols[i] for i in 1:length(structural_cols)]
    end

    if fdtype == Val(:forward)
        # `local` keeps these from aliasing (and thereby boxing) the same-named
        # variables of the enclosing function; see the `vecfx` comment above.
        function calculate_Ji_forward(i)
            local x_save, epsilon, _vecx1, _x1, vecfx1, dx
            x_save = ArrayInterface.allowed_getindex(vecx, i)
            epsilon = compute_epsilon(Val(:forward), x_save, relstep, absstep, dir)
            _vecx1 = setindex(vecx, x_save+epsilon, i)
            _x1 = ArrayInterface.restructure(x, _vecx1)
            vecfx1 = _vec(f(_x1))
            dx = (vecfx1-vecfx) / epsilon
            return dx
        end

        if jac_prototype isa Nothing && sparsity isa Nothing
            J = mapreduce(calculate_Ji_forward, hcat, 1:maximum(colorvec))
            J = _mat(J)
        else
            @inbounds for color_i in 1:maximum(colorvec)
                if sparsity isa Nothing
                    dx = calculate_Ji_forward(color_i)
                    J = J + _make_Ji(J, eltype(x), dx, color_i, nrows, ncols)
                else
                    tmp = norm(vecx .* (colorvec .== color_i))
                    epsilon_c = compute_epsilon(
                        Val(:forward), sqrt(tmp), relstep, absstep, dir)
                    _vecx = @. vecx + epsilon_c * (colorvec == color_i)
                    _x = reshape(_vecx, axes(x))
                    vecfx1 = _vec(f(_x))
                    dx = (vecfx1-vecfx)/epsilon_c
                    Ji = _make_Ji(
                        J, rows_index, cols_index, dx, colorvec, color_i, nrows, ncols)
                    J = J + Ji
                end
            end
        end
    elseif fdtype == Val(:central)
        # Both halves of the central difference must perturb around the *current*
        # x. Reading the unperturbed components from `cache.x1` (issue #213) is
        # unsafe — the cache may have been built via `similar(x)` or reused at a
        # different x — so we always perturb around `vecx` directly.
        function calculate_Ji_central(i)
            local x_save, epsilon, _vecx1, _vecx, _x1, _x, vecfx1, vecfx0, dx
            x_save = ArrayInterface.allowed_getindex(vecx, i)
            epsilon = compute_epsilon(Val(:forward), x_save, relstep, absstep, dir)
            _vecx1 = setindex(vecx, x_save+epsilon, i)
            _vecx = setindex(vecx, x_save-epsilon, i)
            _x1 = reshape(_vecx1, axes(x))
            _x = reshape(_vecx, axes(x))
            vecfx1 = _vec(f(_x1))
            vecfx0 = _vec(f(_x))
            dx = (vecfx1-vecfx0)/(2epsilon)
            return dx
        end

        if jac_prototype isa Nothing && sparsity isa Nothing
            J = mapreduce(calculate_Ji_central, hcat, 1:maximum(colorvec))
            J = _mat(J)
        else
            @inbounds for color_i in 1:maximum(colorvec)
                if sparsity isa Nothing
                    dx = calculate_Ji_central(color_i)
                    J = J + _make_Ji(J, eltype(x), dx, color_i, nrows, ncols)
                else
                    tmp = norm(vecx .* (colorvec .== color_i))
                    epsilon_c = compute_epsilon(
                        Val(:forward), sqrt(tmp), relstep, absstep, dir)
                    _vecx1 = @. vecx + epsilon_c * (colorvec == color_i)
                    _vecx = @. vecx - epsilon_c * (colorvec == color_i)
                    _x1 = reshape(_vecx1, axes(x))
                    _x = reshape(_vecx, axes(x))
                    vecfx1 = _vec(f(_x1))
                    vecfx0 = _vec(f(_x))
                    dx = (vecfx1-vecfx0)/(2epsilon_c)
                    Ji = _make_Ji(
                        J, rows_index, cols_index, dx, colorvec, color_i, nrows, ncols)
                    J = J + Ji
                end
            end
        end
    elseif fdtype == Val(:complex) && returntype <: Real
        epsilon = eps(eltype(x))

        function calculate_Ji_complex(i)
            local x_save, _vecx, _x, vecfx_c, dx
            x_save = ArrayInterface.allowed_getindex(vecx, i)
            _vecx = setindex(complex.(vecx), x_save+im*epsilon, i)
            _x = reshape(_vecx, axes(x))
            vecfx_c = _vec(f(_x))
            dx = imag(vecfx_c)/epsilon
            return dx
        end

        if jac_prototype isa Nothing && sparsity isa Nothing
            J = mapreduce(calculate_Ji_complex, hcat, 1:maximum(colorvec))
            J = _mat(J)
        else
            @inbounds for color_i in 1:maximum(colorvec)
                if sparsity isa Nothing
                    dx = calculate_Ji_complex(color_i)
                    J = J + _make_Ji(J, eltype(x), dx, color_i, nrows, ncols)
                else
                    _vecx = @. vecx + im * epsilon * (colorvec == color_i)
                    _x = reshape(_vecx, axes(x))
                    vecfx_c = _vec(f(_x))
                    dx = imag(vecfx_c)/epsilon
                    Ji = _make_Ji(
                        J, rows_index, cols_index, dx, colorvec, color_i, nrows, ncols)
                    J = J + Ji
                end
            end
        end
    else
        fdtype_error(returntype)
    end
    J
end

"""
    finite_difference_jacobian!(
        J          :: AbstractMatrix,
        f,
        x          :: AbstractArray{<:Number},
        fdtype     :: Type{T1} = Val{:forward},
        returntype :: Type{T2} = eltype(x),
        f_in       :: Union{T2,Nothing}=nothing;
        relstep  = default_relstep(fdtype, eltype(x)),
        absstep  = relstep,
        colorvec = 1:length(x),
        sparsity = ArrayInterfaceCore.has_sparsestruct(J) ? J : nothing)

Cache-less.
"""
function finite_difference_jacobian!(J,
        f,
        x,
        fdtype = Val(:forward),
        returntype = eltype(x),
        f_in = nothing;
        relstep = default_relstep(fdtype, eltype(x)),
        absstep = relstep,
        colorvec = 1:length(x),
        sparsity = ArrayInterface.has_sparsestruct(J) ? J : nothing)
    if f_in isa Nothing && fdtype == Val(:forward)
        if size(J, 1) == length(x)
            fx = zero(x)
        else
            fx = zeros(returntype, size(J, 1))
        end
        f(fx, x)
        cache = JacobianCache(x, fx, fdtype, returntype)
    elseif f_in isa Nothing
        cache = JacobianCache(x, fdtype, returntype)
    else
        cache = JacobianCache(x, f_in, fdtype, returntype)
    end
    finite_difference_jacobian!(J, f, x, cache, cache.fx; relstep = relstep,
        absstep = absstep, colorvec = colorvec, sparsity = sparsity)
end

function _findstructralnz(A::DenseMatrix)
    numnz = count(A .≠ 0)
    I = Vector{Int64}(undef, numnz)
    J = Vector{Int64}(undef, numnz)
    idx = 1
    for j in axes(A, 2)
        for i in axes(A, 1)
            if A[i, j] ≠ 0
                I[idx] = i
                J[idx] = j
                idx += 1
            end
        end
    end
    I, J
end

"""
    FiniteDiff.finite_difference_jacobian!(
        J     :: AbstractMatrix{<:Number},
        f,
        x     :: AbstractArray{<:Number},
        cache :: JacobianCache;
        relstep  = default_relstep(fdtype, eltype(x)),
        absstep  = relstep,
        colorvec = cache.colorvec,
        sparsity = cache.sparsity,
        dir      = true)

Cached.
"""
function finite_difference_jacobian!(
        J,
        f,
        x,
        cache::JacobianCache{T1, T2, T3, T4, cType, sType, fdtype, returntype},
        f_in = nothing;
        relstep = default_relstep(fdtype, eltype(x)),
        absstep = relstep,
        colorvec = cache.colorvec,
        sparsity = cache.sparsity,
        dir = true) where {T1, T2, T3, T4, cType, sType, fdtype, returntype}
    m, n = size(J)
    _color = reshape(colorvec, axes(x)...)

    x1, x2, fx, fx1 = cache.x1, cache.x2, cache.fx, cache.fx1
    copyto!(x1, x)
    vfx = _vec(fx)

    rows_index = nothing
    cols_index = nothing
    if _use_findstructralnz(sparsity)
        rows_index, cols_index = ArrayInterface.findstructralnz(sparsity)
    elseif sparsity isa DenseMatrix
        rows_index, cols_index = FiniteDiff._findstructralnz(sparsity)
    end

    if sparsity !== nothing
        fill_matrix!(J, false)
    end

    # fast path if J and sparsity are both AbstractSparseMatrix and have the same sparsity pattern
    sparseCSC_common_sparsity = _use_sparseCSC_common_sparsity(J, sparsity)

    if fdtype == Val(:forward)
        vfx1 = _vec(fx1)

        if f_in isa Nothing
            f(fx, x)
            vfx = _vec(fx)
        else
            vfx = _vec(f_in)
        end

        @inbounds for color_i in 1:maximum(colorvec)
            if sparsity isa Nothing
                x1_save = ArrayInterface.allowed_getindex(x1, color_i)
                epsilon = compute_epsilon(Val(:forward), x1_save, relstep, absstep, dir)
                ArrayInterface.allowed_setindex!(x1, x1_save + epsilon, color_i)
                f(fx1, x1)
                # J is dense, so either it is truly dense or this is the
                # compressed form of the coloring, so write into it.
                @. J[:, color_i] = (vfx1 - vfx) / epsilon
                # Now return x1 back to its original value
                ArrayInterface.allowed_setindex!(x1, x1_save, color_i)
            else # Perturb along the colorvec vector
                @. x2 = x1 * (_color == color_i)
                tmp = norm(x2)
                epsilon = compute_epsilon(Val(:forward), sqrt(tmp), relstep, absstep, dir)
                @. x1 = x1 + epsilon * (_color == color_i)
                f(fx1, x1)
                # J is a sparse matrix, so decompress on the fly
                @. vfx1 = (vfx1 - vfx) / epsilon
                if ArrayInterface.fast_scalar_indexing(x1)
                    if sparseCSC_common_sparsity
                        _colorediteration!(J, vfx1, colorvec, color_i, n)
                    else
                        _colorediteration!(
                            J, sparsity, rows_index, cols_index, vfx1, colorvec, color_i, n)
                    end
                else
                    #=
                    J.nzval[rows_index] .+= (colorvec[cols_index] .== color_i) .* vfx1[rows_index]
                    or
                    J[rows_index, cols_index] .+= (colorvec[cols_index] .== color_i) .* vfx1[rows_index]
                    += means requires a zero'd out start
                    =#
                    fast_jacobian_setindex!(
                        J, rows_index, cols_index, _color, color_i, vfx1)
                end
                # Now return x1 back to its original value
                @. x1 = x1 - epsilon * (_color == color_i)
            end
        end #for ends here
    elseif fdtype == Val(:central)
        vfx1 = _vec(fx1)
        @inbounds for color_i in 1:maximum(colorvec)
            if sparsity isa Nothing
                x_save = ArrayInterface.allowed_getindex(x, color_i)
                epsilon = compute_epsilon(Val(:central), x_save, relstep, absstep, dir)
                ArrayInterface.allowed_setindex!(x1, x_save + epsilon, color_i)
                f(fx1, x1)
                ArrayInterface.allowed_setindex!(x1, x_save - epsilon, color_i)
                f(fx, x1)
                @. J[:, color_i] = (vfx1 - vfx) / 2epsilon
                ArrayInterface.allowed_setindex!(x1, x_save, color_i)
            else # Perturb along the colorvec vector
                @. x2 = x1 * (_color == color_i)
                tmp = norm(x2)
                epsilon = compute_epsilon(Val(:central), sqrt(tmp), relstep, absstep, dir)
                @. x1 = x1 + epsilon * (_color == color_i)
                @. x = x - epsilon * (_color == color_i)
                f(fx1, x1)
                f(fx, x)
                @. vfx1 = (vfx1 - vfx) / 2epsilon
                if ArrayInterface.fast_scalar_indexing(x1)
                    if sparseCSC_common_sparsity
                        _colorediteration!(J, vfx1, colorvec, color_i, n)
                    else
                        _colorediteration!(
                            J, sparsity, rows_index, cols_index, vfx1, colorvec, color_i, n)
                    end
                else
                    fast_jacobian_setindex!(
                        J, rows_index, cols_index, _color, color_i, vfx1)
                end
                @. x1 = x1 - epsilon * (_color == color_i)
                @. x = x + epsilon * (_color == color_i)
            end
        end
    elseif fdtype==Val(:complex) && returntype<:Real
        epsilon = eps(eltype(x))
        @inbounds for color_i in 1:maximum(colorvec)
            if sparsity isa Nothing
                x1_save = ArrayInterface.allowed_getindex(x1, color_i)
                ArrayInterface.allowed_setindex!(x1, x1_save + im*epsilon, color_i)
                f(fx, x1)
                @. J[:, color_i] = imag(vfx) / epsilon
                ArrayInterface.allowed_setindex!(x1, x1_save, color_i)
            else # Perturb along the colorvec vector
                @. x1 = x1 + im * epsilon * (_color == color_i)
                f(fx, x1)
                @. vfx = imag(vfx) / epsilon
                if ArrayInterface.fast_scalar_indexing(x1)
                    if sparseCSC_common_sparsity
                        _colorediteration!(J, vfx, colorvec, color_i, n)
                    else
                        _colorediteration!(
                            J, sparsity, rows_index, cols_index, vfx, colorvec, color_i, n)
                    end
                else
                    fast_jacobian_setindex!(J, rows_index, cols_index, _color, color_i, vfx)
                end
                @. x1 = x1 - im * epsilon * (_color == color_i)
            end
        end
    else
        fdtype_error(returntype)
    end
    nothing
end

function resize!(cache::JacobianCache, i::Int)
    resize!(cache.x1, i)
    resize!(cache.fx, i)
    cache.fx1 !== nothing && resize!(cache.fx1, i)
    cache.colorvec = 1:i
    nothing
end

@inline fill_matrix!(J, v) = fill!(J, v)

@inline function fast_jacobian_setindex!(J, rows_index, cols_index, _color, color_i, vfx)
    @. void_setindex!((J,),
        getindex((J,), rows_index, cols_index) +
        (getindex((_color,), cols_index) == color_i) * getindex((vfx,), rows_index),
        rows_index,
        cols_index)
end

struct HessianCache{T, fdtype, inplace}
    xpp::T
    xpm::T
    xmp::T
    xmm::T
end

"""
    _hessian_inplace(::Type{T}) where T
    _hessian_inplace(x)

Internal function to determine if Hessian computation should be performed in-place.

Returns `Val(true)` if the array type is mutable and supports in-place operations,
`Val(false)` otherwise. Used to dispatch on StaticArrays vs mutable arrays.

# Arguments
- `::Type{T}` or `x`: Array type or array instance

# Returns
- `Val(true)` if the array type supports in-place mutation
- `Val(false)` if the array type is immutable (e.g., StaticArray)
"""
_hessian_inplace(::Type{T}) where {T} = Val(ArrayInterface.ismutable(T))
_hessian_inplace(x) = _hessian_inplace(typeof(x))

"""
    __Symmetric(x)

Internal utility function that wraps a matrix in a `Symmetric` view.

# Arguments
- `x`: Matrix to be wrapped

# Returns
- `Symmetric(x)`: Symmetric view of the matrix
"""
__Symmetric(x) = Symmetric(x)

"""
    mutable_zeromatrix(x)

Internal utility function to create a mutable zero matrix with the same structure as `x`.

Creates a zero matrix compatible with `x` and ensures it's mutable for in-place operations.
If the created matrix is immutable, it converts it to a mutable copy.

# Arguments
- `x`: Array whose structure should be matched

# Returns
- Mutable zero matrix with the same dimensions and compatible type as `x`
"""
function mutable_zeromatrix(x)
    A = ArrayInterface.zeromatrix(x)
    ArrayInterface.ismutable(A) ? A : Base.copymutable(A)
end

"""
    HessianCache(
        xpp, xpm, xmp, xmm,
        fdtype  :: Type{T1}      = Val{:hcentral},
        inplace :: Type{Val{T2}} = x isa StaticArray ? Val{true} : Val{false})

Non-allocating cache constructor.
"""
function HessianCache(xpp, xpm, xmp, xmm,
        fdtype = Val(:hcentral),
        inplace = _hessian_inplace(x))
    fdtype isa Type && (fdtype = fdtype())
    inplace isa Type && (inplace = inplace())
    HessianCache{typeof(xpp), fdtype, inplace}(xpp, xpm, xmp, xmm)
end

"""
    HessianCache(
        x,
        fdtype  :: Type{T1}      = Val{:hcentral},
        inplace :: Type{Val{T2}} = x isa StaticArray ? Val{true} : Val{false})

Allocating cache constructor.
"""
function HessianCache(x, fdtype = Val(:hcentral),
        inplace = _hessian_inplace(x))
    cx = copy(x)
    fdtype isa Type && (fdtype = fdtype())
    inplace isa Type && (inplace = inplace())
    HessianCache{typeof(cx), fdtype, inplace}(cx, copy(x), copy(x), copy(x))
end

"""
    finite_difference_hessian(
        f,
        x       :: AbstractArray{<:Number},
        fdtype  :: Type{T1}      = Val{:hcentral},
        inplace :: Type{Val{T2}} = x isa StaticArray ? Val{true} : Val{false};
        relstep = default_relstep(fdtype, eltype(x)),
        absstep = relstep)

Compute the Hessian matrix of scalar function `f` at point `x` using finite differences.

This is the cache-less version that allocates temporary arrays internally.
The Hessian `H[i,j] = ∂²f/(∂x[i]∂x[j])` is computed using the specified finite
difference method, typically central differences for optimal accuracy.

# Arguments
- `f`: Scalar-valued function to differentiate (vector→scalar map)
- `x::AbstractArray{<:Number}`: Point at which to evaluate the Hessian
- `fdtype::Type{T1}=Val{:hcentral}`: Finite difference method (`:hcentral` for Hessian central differences)
- `inplace::Type{Val{T2}}`: Whether to use in-place operations (auto-detected for StaticArrays)

# Keyword Arguments
- `relstep`: Relative step size (default: method-dependent optimal value)
- `absstep=relstep`: Absolute step size fallback

# Returns
- Hessian matrix `H` where `H[i,j] = ∂²f/(∂x[i]∂x[j])`
- Returns `Symmetric(H)` view to enforce mathematical symmetry

# Examples
```julia
f(x) = x[1]^2 + x[1]*x[2] + x[2]^2  # Quadratic function
x = [1.0, 2.0]
H = finite_difference_hessian(f, x)  # 2×2 Symmetric matrix
```

# Mathematical Background
For a scalar function `f: ℝⁿ → ℝ`, the Hessian central difference approximation is:
```
H[i,j] ≈ (f(x + eᵢhᵢ + eⱼhⱼ) - f(x + eᵢhᵢ - eⱼhⱼ) - f(x - eᵢhᵢ + eⱼhⱼ) + f(x - eᵢhᵢ - eⱼhⱼ)) / (4hᵢhⱼ)
```
where `eᵢ` is the i-th unit vector and `hᵢ` is the step size in dimension i.

# Notes  
- Requires `O(n²)` function evaluations for an n-dimensional input
- Central differences provide `O(h²)` accuracy for second derivatives
- The result is automatically symmetrized using `Symmetric()` wrapper
- For large problems, consider using `finite_difference_gradient` twice instead
"""
function finite_difference_hessian(f, x,
        fdtype = Val(:hcentral),
        inplace = _hessian_inplace(x);
        relstep = default_relstep(fdtype, eltype(x)),
        absstep = relstep)
    cache = HessianCache(x, fdtype, inplace)
    finite_difference_hessian(f, x, cache; relstep = relstep, absstep = absstep)
end

"""
    finite_difference_hessian(
        f,
        x,
        cache::HessianCache{T,fdtype,inplace};
        relstep=default_relstep(fdtype, eltype(x)),
        absstep=relstep)

Cached.
"""
function finite_difference_hessian(
        f, x,
        cache::HessianCache{T, fdtype, inplace};
        relstep = default_relstep(fdtype, eltype(x)),
        absstep = relstep) where {T, fdtype, inplace}
    H = mutable_zeromatrix(x)
    finite_difference_hessian!(H, f, x, cache; relstep = relstep, absstep = absstep)
    __Symmetric(H)
end

"""
    finite_difference_hessian!(
        H          :: AbstractMatrix,
        f,
        x          :: AbstractArray{<:Number},
        fdtype     :: Type{T1} = Val{:hcentral},
        inplace    :: Type{Val{T2}} = x isa StaticArray ? Val{true} : Val{false};
        relstep = default_relstep(fdtype, eltype(x)),
        absstep = relstep)

Cache-less.
"""
function finite_difference_hessian!(H, f,
        x,
        fdtype = Val(:hcentral),
        inplace = _hessian_inplace(x);
        relstep = default_relstep(fdtype, eltype(x)),
        absstep = relstep)
    cache = HessianCache(x, fdtype, inplace)
    finite_difference_hessian!(H, f, x, cache; relstep = relstep, absstep = absstep)
end

"""
    finite_difference_hessian!(
        H,
        f,
        x,
        cache::HessianCache{T,fdtype,inplace};
        relstep = default_relstep(fdtype, eltype(x)),
        absstep = relstep)

Cached.
"""
function finite_difference_hessian!(H, f, x,
        cache::HessianCache{T, fdtype, inplace};
        relstep = default_relstep(fdtype, eltype(x)),
        absstep = relstep) where {T, fdtype, inplace}
    @assert fdtype == Val(:hcentral)
    n = length(x)
    xpp, xpm, xmp, xmm = cache.xpp, cache.xpm, cache.xmp, cache.xmm
    fx = f(x)

    if inplace === Val(true)
        _xpp, _xpm, _xmp, _xmm = xpp, xpm, xmp, xmm
        copyto!(xpp, x)
        copyto!(xpm, x)
        copyto!(xmp, x)
        copyto!(xmm, x)
    else # ignore the cache since immutable
        xpp, xpm, xmp, xmm = copy(x), copy(x), copy(x), copy(x)
    end

    for i in 1:n
        xi = ArrayInterface.allowed_getindex(x, i)
        epsilon = compute_epsilon(Val(:hcentral), xi, relstep, absstep)

        if inplace === Val(true)
            ArrayInterface.allowed_setindex!(xpp, xi + epsilon, i)
            ArrayInterface.allowed_setindex!(xmm, xi - epsilon, i)
        else
            _xpp = setindex(xpp, xi + epsilon, i)
            _xmm = setindex(xmm, xi - epsilon, i)
        end

        ArrayInterface.allowed_setindex!(H, (f(_xpp) - 2*fx + f(_xmm)) / epsilon^2, i, i)
        epsiloni = compute_epsilon(Val(:central), xi, relstep, absstep)
        xp = xi + epsiloni
        xm = xi - epsiloni

        if inplace === Val(true)
            ArrayInterface.allowed_setindex!(xpp, xp, i)
            ArrayInterface.allowed_setindex!(xpm, xp, i)
            ArrayInterface.allowed_setindex!(xmp, xm, i)
            ArrayInterface.allowed_setindex!(xmm, xm, i)
        else
            _xpp = setindex(xpp, xp, i)
            _xpm = setindex(xpm, xp, i)
            _xmp = setindex(xmp, xm, i)
            _xmm = setindex(xmm, xm, i)
        end

        for j in (i + 1):n
            xj = ArrayInterface.allowed_getindex(x, j)
            epsilonj = compute_epsilon(Val(:central), xj, relstep, absstep)
            xp = xj + epsilonj
            xm = xj - epsilonj

            if inplace === Val(true)
                ArrayInterface.allowed_setindex!(xpp, xp, j)
                ArrayInterface.allowed_setindex!(xpm, xm, j)
                ArrayInterface.allowed_setindex!(xmp, xp, j)
                ArrayInterface.allowed_setindex!(xmm, xm, j)
            else
                _xpp = setindex(_xpp, xp, j)
                _xpm = setindex(_xpm, xm, j)
                _xmp = setindex(_xmp, xp, j)
                _xmm = setindex(_xmm, xm, j)
            end

            ArrayInterface.allowed_setindex!(
                H, (f(_xpp) - f(_xpm) - f(_xmp) + f(_xmm))/(4*epsiloni*epsilonj), i, j)

            if inplace === Val(true)
                ArrayInterface.allowed_setindex!(xpp, xj, j)
                ArrayInterface.allowed_setindex!(xpm, xj, j)
                ArrayInterface.allowed_setindex!(xmp, xj, j)
                ArrayInterface.allowed_setindex!(xmm, xj, j)
            else
                _xpp = setindex(_xpp, xj, j)
                _xpm = setindex(_xpm, xj, j)
                _xmp = setindex(_xmp, xj, j)
                _xmm = setindex(_xmm, xj, j)
            end
        end

        if inplace === Val(true)
            ArrayInterface.allowed_setindex!(xpp, xi, i)
            ArrayInterface.allowed_setindex!(xpm, xi, i)
            ArrayInterface.allowed_setindex!(xmp, xi, i)
            ArrayInterface.allowed_setindex!(xmm, xi, i)
        end
    end
    LinearAlgebra.copytri!(H, 'U')
end

using Documenter, FiniteDiff

DocMeta.setdocmeta!(
    FiniteDiff,
    :DocTestSetup,
    :(using FiniteDiff);
    recursive=true,
)

cp("./docs/Manifest.toml", "./docs/src/assets/Manifest.toml", force=true)
cp("./docs/Project.toml", "./docs/src/assets/Project.toml", force=true)

# create index from README and contributing
open(joinpath(@__DIR__, "src", "index.md"), "w") do io
    println(
        io,
        """
        ```@meta
        EditURL = "https://github.com/JuliaDiff/FiniteDiff.jl/blob/master/README.md"
        ```
        """,
    )
    for line in eachline(joinpath(dirname(@__DIR__), "README.md"))
        println(io, line)
    end

    for line in eachline(joinpath(@__DIR__, "src", "reproducibility.md"))
        println(io, line)
    end
end

include("pages.jl")

makedocs(sitename="FiniteDiff.jl",
    authors="Chris Rackauckas",
    modules=[FiniteDiff],
    clean=true,
    doctest=false,
    format=Documenter.HTML(assets=["assets/favicon.ico"],
        canonical="https://docs.sciml.ai/FiniteDiff/stable/"),
    warnonly=[:missing_docs],
    pages=pages)

deploydocs(repo="github.com/JuliaDiff/FiniteDiff.jl.git"; push_preview=true)

using FiniteDiff, Test, LinearAlgebra, Setfield # should probably create a new Project.toml for tests to use Setfield, not needed in main package

# code quality guards
@test isempty(detect_unbound_args(FiniteDiff))
@test isempty(detect_ambiguities(FiniteDiff))

# TODO: add tests for GPUArrays
# TODO: add tests for DEDataArrays

# Derivative tests
x = collect(range(-2π, stop=2π, length=100))
y = sin.(x)
df = fill(0.0, 100)
epsilon = fill(0.0, 100)
df_ref = cos.(x)
forward_cache = FiniteDiff.DerivativeCache(x, y, epsilon, Val{:forward})
central_cache = FiniteDiff.DerivativeCache(x, nothing, epsilon, Val{:central})
complex_cache = FiniteDiff.DerivativeCache(x, nothing, nothing, Val{:complex})

err_func(a, b) = maximum(abs.(a - b))

@time @testset "Derivative single point f : R -> R tests" begin
    @test err_func(FiniteDiff.finite_difference_derivative(sin, π / 4, Val{:forward}), √2 / 2) < 1e-4
    @test err_func(FiniteDiff.finite_difference_derivative(x -> x > π / 4 ? error() : sin(x), π / 4, Val{:forward}, dir=-1), √2 / 2) < 1e-4
    @test_throws Any err_func(FiniteDiff.finite_difference_derivative(x -> x >= π / 4 ? error() : sin(x), π / 4, Val{:forward}), √2 / 2) < 1e-4
    @test err_func(FiniteDiff.finite_difference_derivative(sin, π / 4, Val{:central}), √2 / 2) < 1e-8
    @test err_func(FiniteDiff.finite_difference_derivative(sin, π / 4, Val{:complex}), √2 / 2) < 1e-15
end

@time @testset "Derivative StridedArray f : R -> R tests" begin
    @test err_func(FiniteDiff.finite_difference_derivative(sin, x, Val{:forward}), df_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_derivative(sin, x, Val{:central}), df_ref) < 1e-8
    @test err_func(FiniteDiff.finite_difference_derivative(sin, x, Val{:complex}), df_ref) < 1e-15

    @test err_func(FiniteDiff.finite_difference_derivative(sin, x, Val{:forward}, eltype(x), y, epsilon), df_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_derivative(sin, x, Val{:central}, eltype(x), y, epsilon), df_ref) < 1e-8
    @test err_func(FiniteDiff.finite_difference_derivative(sin, x, Val{:complex}, eltype(x), y, epsilon), df_ref) < 1e-15

    @test err_func(FiniteDiff.finite_difference_derivative!(df, sin, x, Val{:forward}), df_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_derivative!(df, sin, x, Val{:central}), df_ref) < 1e-8
    @test err_func(FiniteDiff.finite_difference_derivative!(df, sin, x, Val{:complex}), df_ref) < 1e-15

    @test err_func(FiniteDiff.finite_difference_derivative!(df, sin, x, Val{:forward}, eltype(x), y, epsilon), df_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_derivative!(df, sin, x, Val{:central}, eltype(x), y, epsilon), df_ref) < 1e-8
    @test err_func(FiniteDiff.finite_difference_derivative!(df, sin, x, Val{:complex}, eltype(x), y, epsilon), df_ref) < 1e-15

    @test err_func(FiniteDiff.finite_difference_derivative!(df, sin, x, forward_cache), df_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_derivative!(df, sin, x, central_cache), df_ref) < 1e-8
    @test err_func(FiniteDiff.finite_difference_derivative!(df, sin, x, complex_cache), df_ref) < 1e-15
end

x = x + im * x
f(x) = sin(x) + cos(x)
y = f.(x)
df = zero(x)
epsilon = similar(real(x))
df_ref = cos.(x) - sin.(x)
forward_cache = FiniteDiff.DerivativeCache(x, y, epsilon, Val{:forward})
central_cache = FiniteDiff.DerivativeCache(x, y, epsilon, Val{:central})

@time @testset "Derivative single point f : C -> C tests" begin
    @test err_func(FiniteDiff.finite_difference_derivative(f, π / 4 + im * π / 4, Val{:forward}, Val{:Complex}), cos(π / 4 + im * π / 4) - sin(π / 4 + im * π / 4)) < 1e-3
    @test err_func(FiniteDiff.finite_difference_derivative(f, π / 4 + im * π / 4, Val{:central}, Val{:Complex}), cos(π / 4 + im * π / 4) - sin(π / 4 + im * π / 4)) < 1e-7
end

@time @testset "Derivative StridedArray f : C -> C tests" begin
    @test err_func(FiniteDiff.finite_difference_derivative(f, x, Val{:forward}), df_ref) < 1e-3
    @test err_func(FiniteDiff.finite_difference_derivative(f, x, Val{:central}), df_ref) < 1e-6

    @test err_func(FiniteDiff.finite_difference_derivative(f, x, Val{:forward}, eltype(x), y), df_ref) < 1e-3
    @test err_func(FiniteDiff.finite_difference_derivative(f, x, Val{:central}, eltype(x), y), df_ref) < 1e-6

    @test err_func(FiniteDiff.finite_difference_derivative(f, x, Val{:forward}, eltype(x), y, epsilon), df_ref) < 1e-3
    @test err_func(FiniteDiff.finite_difference_derivative(f, x, Val{:central}, eltype(x), y, epsilon), df_ref) < 1e-6

    @test err_func(FiniteDiff.finite_difference_derivative!(df, f, x, Val{:forward}, eltype(x)), df_ref) < 1e-3
    @test err_func(FiniteDiff.finite_difference_derivative!(df, f, x, Val{:central}, eltype(x)), df_ref) < 1e-6

    @test err_func(FiniteDiff.finite_difference_derivative!(df, f, x, Val{:forward}, eltype(x), y), df_ref) < 1e-3
    @test err_func(FiniteDiff.finite_difference_derivative!(df, f, x, Val{:central}, eltype(x), y), df_ref) < 1e-6

    @test err_func(FiniteDiff.finite_difference_derivative!(df, f, x, Val{:forward}, eltype(x), y, epsilon), df_ref) < 1e-3
    @test err_func(FiniteDiff.finite_difference_derivative!(df, f, x, Val{:central}, eltype(x), y, epsilon), df_ref) < 1e-6

    @test err_func(FiniteDiff.finite_difference_derivative!(df, f, x, forward_cache), df_ref) < 1e-3
    @test err_func(FiniteDiff.finite_difference_derivative!(df, f, x, central_cache), df_ref) < 1e-6
end

x = collect(range(-2π, stop=2π, length=100))
f(x) = sin(x) + im * cos(x)
y = f.(x)
df = fill(zero(Complex{eltype(x)}), size(x))
epsilon = similar(real(x))
df_ref = cos.(x) - im * sin.(x)
forward_cache = FiniteDiff.DerivativeCache(x, y, epsilon, Val{:forward}, eltype(df))
central_cache = FiniteDiff.DerivativeCache(x, y, epsilon, Val{:central}, eltype(df))

@time @testset "Derivative single point f : R -> C tests" begin
    @test err_func(FiniteDiff.finite_difference_derivative(f, π / 4, Val{:forward}, Val{:Complex}), cos(π / 4) - im * sin(π / 4)) < 1e-3
    @test err_func(FiniteDiff.finite_difference_derivative(f, π / 4, Val{:central}, Val{:Complex}), cos(π / 4) - im * sin(π / 4)) < 1e-7
end

@time @testset "Derivative StridedArray f : R -> C tests" begin
    @test err_func(FiniteDiff.finite_difference_derivative(f, x, Val{:forward}, Complex{eltype(x)}), df_ref) < 1e-3
    @test err_func(FiniteDiff.finite_difference_derivative(f, x, Val{:forward}, Complex{eltype(x)}, relstep=sqrt(eps())), df_ref) < 1e-3
    @test err_func(FiniteDiff.finite_difference_derivative(f, x, Val{:central}, Complex{eltype(x)}), df_ref) < 1e-6

    @test err_func(FiniteDiff.finite_difference_derivative(f, x, Val{:forward}, Complex{eltype(x)}, y), df_ref) < 1e-3
    @test err_func(FiniteDiff.finite_difference_derivative(f, x, Val{:forward}, Complex{eltype(x)}, y, relstep=sqrt(eps())), df_ref) < 1e-3
    @test err_func(FiniteDiff.finite_difference_derivative(f, x, Val{:central}, Complex{eltype(x)}, y), df_ref) < 1e-6

    @test err_func(FiniteDiff.finite_difference_derivative(f, x, Val{:forward}, Complex{eltype(x)}, y, epsilon), df_ref) < 1e-3
    @test err_func(FiniteDiff.finite_difference_derivative(f, x, Val{:forward}, Complex{eltype(x)}, y, epsilon, relstep=sqrt(eps())), df_ref) < 1e-3
    @test err_func(FiniteDiff.finite_difference_derivative(f, x, Val{:central}, Complex{eltype(x)}, y, epsilon), df_ref) < 1e-6

    @test err_func(FiniteDiff.finite_difference_derivative!(df, f, x, Val{:forward}, Complex{eltype(x)}), df_ref) < 1e-3
    @test err_func(FiniteDiff.finite_difference_derivative!(df, f, x, Val{:forward}, Complex{eltype(x)}, relstep=sqrt(eps())), df_ref) < 1e-3
    @test err_func(FiniteDiff.finite_difference_derivative!(df, f, x, Val{:central}, Complex{eltype(x)}), df_ref) < 1e-6

    @test err_func(FiniteDiff.finite_difference_derivative!(df, f, x, Val{:forward}, Complex{eltype(x)}, y), df_ref) < 1e-3
    @test err_func(FiniteDiff.finite_difference_derivative!(df, f, x, Val{:forward}, Complex{eltype(x)}, y, relstep=sqrt(eps())), df_ref) < 1e-3
    @test err_func(FiniteDiff.finite_difference_derivative!(df, f, x, Val{:central}, Complex{eltype(x)}, y), df_ref) < 1e-6

    @test err_func(FiniteDiff.finite_difference_derivative!(df, f, x, Val{:forward}, Complex{eltype(x)}, y, epsilon), df_ref) < 1e-3
    @test err_func(FiniteDiff.finite_difference_derivative!(df, f, x, Val{:forward}, Complex{eltype(x)}, y, epsilon, relstep=sqrt(eps())), df_ref) < 1e-3
    @test err_func(FiniteDiff.finite_difference_derivative!(df, f, x, Val{:central}, Complex{eltype(x)}, y, epsilon), df_ref) < 1e-6

    @test err_func(FiniteDiff.finite_difference_derivative!(df, f, x, forward_cache), df_ref) < 1e-3
    @test err_func(FiniteDiff.finite_difference_derivative!(df, f, x, forward_cache, relstep=sqrt(eps())), df_ref) < 1e-3
    @test err_func(FiniteDiff.finite_difference_derivative!(df, f, x, central_cache), df_ref) < 1e-6
end

#=
x = x + im*x
f(x) = abs2(x)
y = f.(x)
df = fill(zero(eltype(x)), size(x))
epsilon = similar(real(x))
df_ref = 2*conj.(x)
forward_cache = FiniteDiff.DerivativeCache(x, y, epsilon, Val{:forward}, eltype(df))
central_cache = FiniteDiff.DerivativeCache(x, y, epsilon, Val{:central}, eltype(df))
@show typeof(FiniteDiff.finite_difference_derivative(f, 1.+im*1., Val{:forward}, real(eltype(x))))

@time @testset "Derivative single point f : C -> R tests" begin
    @test err_func(FiniteDiff.finite_difference_derivative(f, 1.+im*1., Val{:forward}, real(eltype(x))), 2.-2.*im) < 1e-3
    @test err_func(FiniteDiff.finite_difference_derivative(f, 1.+im*1., Val{:central}, real(eltype(x))), 2.-2.*im) < 1e-7
end

@time @testset "Derivative StridedArray f : C -> R tests" begin
    @test err_func(FiniteDiff.finite_difference_derivative(f, x, Val{:forward}, real(eltype(x))), df_ref) < 1e-3
    @test err_func(FiniteDiff.finite_difference_derivative(f, x, Val{:central}, real(eltype(x))), df_ref) < 1e-6

    @test err_func(FiniteDiff.finite_difference_derivative(f, x, Val{:forward}, real(eltype(x)), y), df_ref) < 1e-3
    @test err_func(FiniteDiff.finite_difference_derivative(f, x, Val{:central}, real(eltype(x)), y), df_ref) < 1e-6

    @test err_func(FiniteDiff.finite_difference_derivative(f, x, Val{:forward}, real(eltype(x)), y, epsilon), df_ref) < 1e-3
    @test err_func(FiniteDiff.finite_difference_derivative(f, x, Val{:central}, real(eltype(x)), y, epsilon), df_ref) < 1e-6

    @test err_func(FiniteDiff.finite_difference_derivative!(df, f, x, Val{:forward}, real(eltype(x))), df_ref) < 1e-3
    @test err_func(FiniteDiff.finite_difference_derivative!(df, f, x, Val{:central}, real(eltype(x))), df_ref) < 1e-6

    @test err_func(FiniteDiff.finite_difference_derivative!(df, f, x, Val{:forward}, real(eltype(x)), y), df_ref) < 1e-3
    @test err_func(FiniteDiff.finite_difference_derivative!(df, f, x, Val{:central}, real(eltype(x)), y), df_ref) < 1e-6

    @test err_func(FiniteDiff.finite_difference_derivative!(df, f, x, Val{:forward}, real(eltype(x)), y, epsilon), df_ref) < 1e-3
    @test err_func(FiniteDiff.finite_difference_derivative!(df, f, x, Val{:central}, real(eltype(x)), y, epsilon), df_ref) < 1e-6

    @test err_func(FiniteDiff.finite_difference_derivative!(df, f, x, forward_cache), df_ref) < 1e-3
    @test err_func(FiniteDiff.finite_difference_derivative!(df, f, x, central_cache), df_ref) < 1e-6
end
=#

# Gradient tests
f(x) = 2x[1] + x[2]^2
x = rand(2)
z = copy(x)
ff(k) = !all(k .<= z) ? error() : f(k)
fx = f(x)
df = fill(0.0, 2)
df_ref = [2.0, 2 * x[2]]
forward_cache = FiniteDiff.GradientCache(df, x, Val{:forward})
central_cache = FiniteDiff.GradientCache(df, x, Val{:central})
complex_cache = FiniteDiff.GradientCache(df, x, Val{:complex})

@time @testset "Gradient of f:vector->scalar real-valued tests" begin
    @test err_func(FiniteDiff.finite_difference_gradient(f, x, Val{:forward}), df_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_gradient(ff, x, Val{:forward}, dir=-1), df_ref) < 1e-4
    @test_throws Any err_func(FiniteDiff.finite_difference_gradient(ff, x, Val{:forward}), df_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_gradient(f, x, Val{:forward}, relstep=sqrt(eps())), df_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_gradient(f, x, Val{:central}), df_ref) < 1e-8
    @test err_func(FiniteDiff.finite_difference_gradient(f, x, Val{:complex}), df_ref) < 1e-15

    @test err_func(FiniteDiff.finite_difference_gradient!(df, f, x, Val{:forward}), df_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_gradient!(df, f, x, Val{:forward}, relstep=sqrt(eps())), df_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_gradient!(df, f, x, Val{:central}), df_ref) < 1e-8
    @test err_func(FiniteDiff.finite_difference_gradient!(df, f, x, Val{:complex}), df_ref) < 1e-15

    @test err_func(FiniteDiff.finite_difference_gradient!(df, f, x, forward_cache), df_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_gradient!(df, f, x, forward_cache, relstep=sqrt(eps())), df_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_gradient!(df, f, x, central_cache), df_ref) < 1e-8
    @test err_func(FiniteDiff.finite_difference_gradient!(df, f, x, complex_cache), df_ref) < 1e-15
end

f(x) = 2x[1] + im * 2x[1] + x[2]^2
x = x + im * x
fx = f(x)
df = zero(x)
df_ref = conj([2.0 + 2.0 * im, 2.0 * x[2]])
forward_cache = FiniteDiff.GradientCache(df, x, Val{:forward})
central_cache = FiniteDiff.GradientCache(df, x, Val{:central})

@time @testset "Gradient of f : C^N -> C tests" begin
    @test err_func(FiniteDiff.finite_difference_gradient(f, x, Val{:forward}), df_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_gradient(f, x, Val{:forward}, relstep=sqrt(eps())), df_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_gradient(f, x, Val{:central}), df_ref) < 1e-8

    @test err_func(FiniteDiff.finite_difference_gradient!(df, f, x, Val{:forward}), df_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_gradient!(df, f, x, Val{:forward}, relstep=sqrt(eps())), df_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_gradient!(df, f, x, Val{:central}), df_ref) < 1e-8

    @test err_func(FiniteDiff.finite_difference_gradient!(df, f, x, forward_cache), df_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_gradient!(df, f, x, forward_cache, relstep=sqrt(eps())), df_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_gradient!(df, f, x, central_cache), df_ref) < 1e-8
end

f(x) = sum(abs2, x)
x = ones(2) * (1 + im)
fx = f(x)
df = zero(x)
df_ref = 2 * x
forward_cache = FiniteDiff.GradientCache(df, x, Val{:forward})
central_cache = FiniteDiff.GradientCache(df, x, Val{:central})

@time @testset "Gradient of f : C^N -> R tests" begin
    @test err_func(FiniteDiff.finite_difference_gradient(f, x, Val{:forward}), df_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_gradient(f, x, Val{:central}), df_ref) < 1e-8

    @test err_func(FiniteDiff.finite_difference_gradient!(df, f, x, Val{:forward}), df_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_gradient!(df, f, x, Val{:central}), df_ref) < 1e-8

    @test err_func(FiniteDiff.finite_difference_gradient!(df, f, x, forward_cache), df_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_gradient!(df, f, x, central_cache), df_ref) < 1e-8
end

f(x) = 2 * x[1] + im * x[2]^2
x = ones(2)
fx = f(x)
df = fill(zero(eltype(fx)), size(x))
df_ref = [2.0, -im * 2 * x[2]]
forward_cache = FiniteDiff.GradientCache(df, x, Val{:forward}, eltype(df))
central_cache = FiniteDiff.GradientCache(df, x, Val{:central}, eltype(df))

@time @testset "Gradient of f : R^N -> C tests" begin
    @test err_func(FiniteDiff.finite_difference_gradient(f, x, Val{:forward}, eltype(df)), df_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_gradient(f, x, Val{:central}, eltype(df)), df_ref) < 1e-8

    @test err_func(FiniteDiff.finite_difference_gradient!(df, f, x, Val{:forward}, eltype(df)), df_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_gradient!(df, f, x, Val{:central}, eltype(df)), df_ref) < 1e-8

    @test err_func(FiniteDiff.finite_difference_gradient!(df, f, x, forward_cache), df_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_gradient!(df, f, x, central_cache), df_ref) < 1e-8
end

f(df, x) = (df[1] = sin(x); df[2] = cos(x); df)
z = x = 2π * rand()
fx = fill(0.0, 2)
f(fx, x)
ff(df, x) = !all(x .<= z) ? error() : f(df, x)
df = fill(0.0, 2)
df_ref = [cos(x), -sin(x)]
forward_cache = FiniteDiff.GradientCache(df, x, Val{:forward})
central_cache = FiniteDiff.GradientCache(df, x, Val{:central})
complex_cache = FiniteDiff.GradientCache(df, x, Val{:complex})


@time @testset "Gradient of f:scalar->vector real-valued tests" begin
    @test_broken err_func(FiniteDiff.finite_difference_gradient(f, x, Val{:forward}), df_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_gradient(f, x, Val{:forward}, eltype(x), Val{true}, fx), df_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_gradient(ff, x, Val{:forward}, eltype(x), Val{true}, fx, dir=-1), df_ref) < 1e-4
    @test_throws Any err_func(FiniteDiff.finite_difference_gradient(ff, x, Val{:forward}), df_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_gradient(f, x, Val{:central}, eltype(x), Val{true}, fx), df_ref) < 1e-8
    @test err_func(FiniteDiff.finite_difference_gradient(f, x, Val{:complex}, eltype(x), Val{true}, fx), df_ref) < 1e-15

    @test err_func(FiniteDiff.finite_difference_gradient!(df, f, x, Val{:forward}), df_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_gradient!(df, f, x, Val{:central}), df_ref) < 1e-8
    @test err_func(FiniteDiff.finite_difference_gradient!(df, f, x, Val{:complex}), df_ref) < 1e-15

    @test err_func(FiniteDiff.finite_difference_gradient!(df, f, x, forward_cache), df_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_gradient!(df, f, x, central_cache), df_ref) < 1e-8
    @test err_func(FiniteDiff.finite_difference_gradient!(df, f, x, complex_cache), df_ref) < 1e-15
end

@time @testset "Gradient of f:scalar->vector with immutable output" begin
    # Regression test: finite_difference_gradient with scalar x must work
    # when f returns immutable arrays, since the out-of-place API should
    # never need to mutate the result. This failed previously because the
    # cached version called finite_difference_gradient! which used @. df = ...
    # to write into an immutable buffer.
    #
    # We use a wrapper around a regular Vector that blocks setindex! to
    # simulate immutable array types (like StaticArrays.SVector or
    # ArrayPartition containing SVectors).
    struct ReadOnlyVec{T} <: AbstractVector{T}
        data::Vector{T}
    end
    Base.size(v::ReadOnlyVec) = size(v.data)
    Base.getindex(v::ReadOnlyVec, i::Int) = v.data[i]
    Base.setindex!(::ReadOnlyVec, _, ::Int) = error("ReadOnlyVec does not support setindex!")
    Base.similar(v::ReadOnlyVec) = ReadOnlyVec(zeros(eltype(v), length(v)))
    Base.zero(v::ReadOnlyVec) = ReadOnlyVec(zeros(eltype(v), length(v)))
    # Out-of-place broadcast returns a plain Vector (like SVector .+ SVector returns SVector)
    Base.BroadcastStyle(::Type{<:ReadOnlyVec}) = Broadcast.DefaultArrayStyle{1}()

    g(t) = ReadOnlyVec([sin(t), cos(t)])
    t0 = 1.0
    g_ref = [cos(t0), -sin(t0)]

    # Out-of-place cached version (the bug path)
    df_template = similar(g(t0))
    for fdtype in (Val(:forward), Val(:central))
        cache = FiniteDiff.GradientCache(df_template, t0, fdtype, Float64, Val(false))
        result = FiniteDiff.finite_difference_gradient(g, t0, cache)
        @test err_func(collect(result), g_ref) < 1e-4
    end
end

f(df, x) = (df[1] = sin(x); df[2] = cos(x); df)
x = (2π * rand()) * (1 + im)
fx = fill(zero(typeof(x)), 2)
f(fx, x)
df = zero(fx)
df_ref = [cos(x), -sin(x)]
forward_cache = FiniteDiff.GradientCache(df, x, Val{:forward})
central_cache = FiniteDiff.GradientCache(df, x, Val{:central})

@time @testset "Gradient of f:vector->scalar complex-valued tests" begin
    @test err_func(FiniteDiff.finite_difference_gradient(f, x, Val{:forward}, eltype(x), Val{true}, fx), df_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_gradient(f, x, Val{:central}, eltype(x), Val{true}, fx), df_ref) < 3e-7

    @test err_func(FiniteDiff.finite_difference_gradient!(df, f, x, Val{:forward}), df_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_gradient!(df, f, x, Val{:central}), df_ref) < 3e-7

    @test err_func(FiniteDiff.finite_difference_gradient!(df, f, x, forward_cache), df_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_gradient!(df, f, x, central_cache), df_ref) < 3e-7
end

# Force specialization on the function argument. Without `::F where {F}`, Julia
# does not specialize this helper on `_f` (a bare Function it only forwards), so
# the inner call dispatches dynamically and the wrapper itself allocates ~48
# bytes on 1.10/1.11 (0 on 1.12+) — a measurement artifact, not library work.
function ret_allocs(res, _f::F, x, cache) where {F}
    allocs = @allocated FiniteDiff.finite_difference_gradient!(res, _f, x, cache)
    allocs
end

@time @testset "Non-allocating cache construction" begin
    _f(x) = x[1]^2 + x[2]^2
    _∇f(x) = [2x[1], 2x[2]]
    x = [1.7, 2.0]
    gradcache_def = FiniteDiff.GradientCache(_f(x), copy(x), copy(x), copy(x))
    gradcache_fd = FiniteDiff.GradientCache(_f(x),copy(x), copy(x), copy(x), Val(:forward))
    gradcache_fdrt = FiniteDiff.GradientCache(_f(x),copy(x), copy(x), copy(x), Val(:forward), Float64)
    gradcache_fdrtiip = FiniteDiff.GradientCache(_f(x),copy(x), copy(x), copy(x), Val(:forward), Float64, Val(false))
    gradcache_rtiip = FiniteDiff.GradientCache(_f(x),copy(x), copy(x), copy(x), Val(:central), Float64, Val(false))
    gradcache_iip = FiniteDiff.GradientCache(_f(x),copy(x), copy(x), copy(x), Val(:central), Float64, Val(false))

    # Gradient computation
    res = zero(x)
    FiniteDiff.finite_difference_gradient!(res, _f, x, gradcache_def)
    @test res ≈ _∇f(x)
    for cache in [gradcache_def, gradcache_fd, gradcache_fdrt, gradcache_fdrtiip, gradcache_rtiip, gradcache_iip]
        res = zero(x)
        FiniteDiff.finite_difference_gradient!(res, _f, x, cache)
        @test res ≈ _∇f(x)
        @test ret_allocs(res, _f, x, cache) == 0

        # Can we now change the field?
        _x = rand(2)
        _cache = deepcopy(cache)
        _cache = @set _cache.fx = _f(_x)
        FiniteDiff.finite_difference_gradient!(res, _f,_x, _cache)
        @test res ≈ _∇f(_x)
        @test ret_allocs(res, _f, _x, _cache) == 0
    end

    _g(x) = x[1]^2 + x[2]
    _∇g(x) = [2x[1], 1.0]
    x = [1.0, 3.0]
    fx = _g(x)
    c1, c2 = zero(x), zero(x)
    c3 = zero(x)
    res = zero(x)
    gcache = FiniteDiff.GradientCache{Float64, Vector{Float64}, Vector{Float64}, Vector{Float64}, Val(:forward), Float64, Val(false)}(fx, c1, c2, c3)
    FiniteDiff.finite_difference_gradient!(res, _g, x, gcache)
    @test res ≈ _∇g(x)
    x = [2.7, 1.0]
    gcache = @set gcache.fx = _g(x)
    FiniteDiff.finite_difference_gradient!(res, _g, x, gcache)
    @test res ≈ _∇g(x)
end

# Jacobian tests
function iipf(fvec, x)
    fvec[1] = (x[1] + 3) * (x[2]^3 - 7) + 18
    fvec[2] = sin(x[2] * exp(x[1]) - 1)
end
function oopf(x)
    [(x[1] + 3) * (x[2]^3 - 7) + 18,
        sin(x[2] * exp(x[1]) - 1)]
end
x = rand(2);
y = rand(2);
z = copy(x)
iipff(df, x) = !all(x .<= z) ? error() : iipf(df, x)
iipf(y, x)
oopff(x) = !all(x .<= z) ? error() : oopf(x)
J_ref = [[-7 + x[2]^3 3 * (3 + x[1]) * x[2]^2]; [exp(x[1]) * x[2] * cos(1 - exp(x[1]) * x[2]) exp(x[1]) * cos(1 - exp(x[1]) * x[2])]]
J = zero(J_ref)
df = zero(x)
df_ref = diag(J_ref)
epsilon = zero(x)
forward_cache = FiniteDiff.JacobianCache(x, Val{:forward}, eltype(x))
forward_jvp_cache = FiniteDiff.JVPCache(x, Val{:forward})
@test forward_cache.colorvec == 1:length(x)
central_cache = FiniteDiff.JacobianCache(x, Val{:central}, eltype(x))
central_jvp_cache = FiniteDiff.JVPCache(x, Val{:central})
complex_cache = FiniteDiff.JacobianCache(x, Val{:complex}, eltype(x))
f_in = copy(y)
vdir = rand(2)
jvp_ref = J_ref*vdir

@time @testset "Out-of-Place Jacobian StridedArray real-valued tests" begin
    @test err_func(FiniteDiff.finite_difference_jacobian(oopf, x, forward_cache), J_ref) < 1e-6
    @test err_func(FiniteDiff.finite_difference_jacobian(oopff, x, forward_cache, dir=-1), J_ref) < 1e-6
    @test_throws Any err_func(FiniteDiff.finite_difference_jacobian(oopff, x, forward_cache), J_ref) < 1e-6
    @test err_func(FiniteDiff.finite_difference_jacobian(oopf, x, forward_cache, relstep=sqrt(eps())), J_ref) < 1e-6
    @test err_func(FiniteDiff.finite_difference_jacobian(oopf, x, forward_cache, f_in), J_ref) < 1e-6
    @test err_func(FiniteDiff.finite_difference_jacobian(oopf, x, central_cache), J_ref) < 1e-8
    @test err_func(FiniteDiff.finite_difference_jacobian(oopf, x, Val{:central}), J_ref) < 1e-8
    @test err_func(FiniteDiff.finite_difference_jacobian(oopf, x, complex_cache), J_ref) < 1e-14
end

@time @testset "Out-of-Place JVP StridedArray real-valued tests" begin
    @test err_func(FiniteDiff.finite_difference_jvp(oopf, x, vdir, forward_jvp_cache), jvp_ref) < 1e-6
    @test err_func(FiniteDiff.finite_difference_jvp(oopff, x, vdir, forward_jvp_cache, dir=-1), jvp_ref) < 1e-6
    @test_throws Any err_func(FiniteDiff.finite_difference_jvp(oopff, x, vdir, forward_jvp_cache), jvp_ref) < 1e-6
    @test err_func(FiniteDiff.finite_difference_jvp(oopf, x, vdir, forward_jvp_cache, relstep=sqrt(eps())), jvp_ref) < 1e-6
    @test err_func(FiniteDiff.finite_difference_jvp(oopf, x, vdir, forward_jvp_cache, f_in), jvp_ref) < 1e-6
    @test err_func(FiniteDiff.finite_difference_jvp(oopf, x, vdir, central_jvp_cache), jvp_ref) < 1e-8
    @test err_func(FiniteDiff.finite_difference_jvp(oopf, x, vdir, Val{:central}), jvp_ref) < 1e-8
end

function test_iipJac(J_ref, args...; kwargs...)
    _J = zero(J_ref)
    FiniteDiff.finite_difference_jacobian!(_J, args...; kwargs...)
    _J
end
@time @testset "inPlace Jacobian StridedArray real-valued tests" begin
    @test err_func(test_iipJac(J_ref, iipf, x, forward_cache), J_ref) < 1e-6
    @test err_func(test_iipJac(J_ref, iipff, x, forward_cache, dir=-1), J_ref) < 1e-6
    @test_throws Any err_func(test_iipJac(J_ref, iipff, x, forward_cache), J_ref) < 1e-6
    @test err_func(test_iipJac(J_ref, iipf, x, forward_cache, relstep=sqrt(eps())), J_ref) < 1e-6
    @test err_func(test_iipJac(J_ref, iipf, x, forward_cache, f_in), J_ref) < 1e-6
    @test err_func(test_iipJac(J_ref, iipf, x, central_cache), J_ref) < 1e-8
    @test err_func(test_iipJac(J_ref, iipf, x, Val{:central}), J_ref) < 1e-8
    @test err_func(test_iipJac(J_ref, iipf, x, complex_cache), J_ref) < 1e-14
end

function test_iipJVP(jvp_ref, args...; kwargs...)
    _jvp = zero(jvp_ref)
    FiniteDiff.finite_difference_jvp!(_jvp, args...; kwargs...)
    _jvp
end

@time @testset "inPlace JVP StridedArray real-valued tests" begin
    @test err_func(test_iipJVP(jvp_ref, iipf, x, vdir, forward_jvp_cache), jvp_ref) < 1e-6
    @test err_func(test_iipJVP(jvp_ref, iipff, x, vdir, forward_jvp_cache, dir=-1), jvp_ref) < 1e-6
    @test_throws Any err_func(test_iipJVP(jvp_ref, iipff, x, vdir, forward_jvp_cache), jvp_ref) < 1e-6
    @test err_func(test_iipJVP(jvp_ref, iipf, x, vdir, forward_jvp_cache, relstep=sqrt(eps())), jvp_ref) < 1e-6
    @test err_func(test_iipJVP(jvp_ref, iipf, x, vdir, forward_jvp_cache, f_in), jvp_ref) < 1e-6
    @test err_func(test_iipJVP(jvp_ref, iipf, x, vdir, central_jvp_cache), jvp_ref) < 1e-8
    @test err_func(test_iipJVP(jvp_ref, iipf, x, vdir, Val{:central}), jvp_ref) < 1e-8
end

function iipf(fvec, x)
    fvec[1] = (im * x[1] + 3) * (x[2]^3 - 7) + 18
    fvec[2] = sin(x[2] * exp(x[1]) - 1)
end
function oopf(x)
    [(im * x[1] + 3) * (x[2]^3 - 7) + 18,
        sin(x[2] * exp(x[1]) - 1)]
end
x = rand(2) + im * rand(2)
y = similar(x)
iipf(y, x)
J_ref = [[im * (-7 + x[2]^3) 3 * (3 + im * x[1]) * x[2]^2]; [exp(x[1]) * x[2] * cos(1 - exp(x[1]) * x[2]) exp(x[1]) * cos(1 - exp(x[1]) * x[2])]]
J = zero(J_ref)
df = zero(x)
df_ref = diag(J_ref)
epsilon = zero(real.(x))
forward_cache = FiniteDiff.JacobianCache(x, Val{:forward}, eltype(x))
central_cache = FiniteDiff.JacobianCache(x, Val{:central}, eltype(x))
f_in = copy(y)

@time @testset "Out-of-Place Jacobian StridedArray f : C^N -> C^N tests" begin
    @test err_func(FiniteDiff.finite_difference_jacobian(oopf, x, forward_cache), J_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_jacobian(oopf, x, forward_cache, relstep=sqrt(eps())), J_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_jacobian(oopf, x, forward_cache, f_in), J_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_jacobian(oopf, x, central_cache), J_ref) < 1e-8
    @test err_func(FiniteDiff.finite_difference_jacobian(oopf, x, Val{:central}), J_ref) < 1e-8
end
@time @testset "inPlace Jacobian StridedArray f : C^N -> C^N tests" begin
    @test err_func(test_iipJac(J_ref, iipf, x, forward_cache), J_ref) < 1e-4
    @test err_func(test_iipJac(J_ref, iipf, x, forward_cache, relstep=sqrt(eps())), J_ref) < 1e-4
    @test err_func(test_iipJac(J_ref, iipf, x, forward_cache, f_in), J_ref) < 1e-4
    @test err_func(test_iipJac(J_ref, iipf, x, central_cache), J_ref) < 1e-8
    @test err_func(test_iipJac(J_ref, iipf, x, Val{:central}), J_ref) < 1e-8
end

# Non vector input
x = rand(2, 2)
oopf(x) = x
iipf(fx, x) = (fx .= x)
J_ref = Matrix{Float64}(I, 4, 4)
@time @testset "Jacobian for non-vector inputs" begin
    @test err_func(FiniteDiff.finite_difference_jacobian(oopf, x, Val{:forward}), J_ref) < 1e-8
    @test err_func(FiniteDiff.finite_difference_jacobian(oopf, x, Val{:central}), J_ref) < 1e-8
    @test err_func(FiniteDiff.finite_difference_jacobian(oopf, x, Val{:complex}), J_ref) < 1e-8
    @test err_func(test_iipJac(J_ref, iipf, x, Val{:forward}, eltype(x), iipf(similar(x), x)), J_ref) < 1e-8
    @test err_func(test_iipJac(J_ref, iipf, x, Val{:central}, eltype(x), iipf(similar(x), x)), J_ref) < 1e-8
    @test err_func(test_iipJac(J_ref, iipf, x, Val{:complex}, eltype(x), iipf(similar(x), x)), J_ref) < 1e-8
end

# Range input for out-of-place function
x = range(rand(), rand(); length=2)
z = copy(x)
y = similar(x)
oopf(x) = @. x^2 + sin(x)
J_ref = [2*x[1]+cos(x[1]) 0.0; 0.0 2*x[2]+cos(x[2])]
J = zero(J_ref)
oopff(x) = !all(x .<= z) ? error() : oopf(x)
epsilon = zero(x)
forward_cache = FiniteDiff.JacobianCache(x, Val{:forward}, eltype(x))
central_cache = FiniteDiff.JacobianCache(x, Val{:central}, eltype(x))
complex_cache = FiniteDiff.JacobianCache(x, Val{:complex}, eltype(x))
f_in = oopf(x)

@time @testset "Out-of-Place Jacobian real-valued tests with range input" begin
    @test err_func(FiniteDiff.finite_difference_jacobian(oopf, x, forward_cache), J_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_jacobian(oopff, x, forward_cache, dir=-1), J_ref) < 1e-4
    @test_throws Any err_func(FiniteDiff.finite_difference_jacobian(oopff, x, forward_cache), J_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_jacobian(oopf, x, forward_cache, relstep=sqrt(eps())), J_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_jacobian(oopf, x, forward_cache, f_in), J_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_jacobian(oopf, x, central_cache), J_ref) < 1e-8
    @test err_func(FiniteDiff.finite_difference_jacobian(oopf, x, Val{:central}), J_ref) < 1e-8
    @test err_func(FiniteDiff.finite_difference_jacobian(oopf, x, complex_cache), J_ref) < 1e-14
end

# Test default colorvec construction
θ = rand(2)
y0 = rand(1)
cache = FiniteDiff.JacobianCache(copy(θ), copy(y0), copy(y0), Val(:forward))
@test cache.colorvec == 1:length(θ)

# Hessian tests

f(x) = sin(x[1]) + cos(x[2])
x = rand(2)
H_ref = [-sin(x[1]) 0.0; 0.0 -cos(x[2])]
hcache = FiniteDiff.HessianCache(x)
hcache_oop = FiniteDiff.HessianCache(x, Val{:hcentral}, Val{false})
H = similar(H_ref)

@time @testset "Hessian StridedArray f : R^N -> R tests" begin
    @test err_func(FiniteDiff.finite_difference_hessian(f, x), H_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_hessian(f, x, hcache), H_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_hessian(f, x, hcache_oop), H_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_hessian!(H, f, x), H_ref) < 1e-4
    @test err_func(FiniteDiff.finite_difference_hessian!(H, f, x, hcache), H_ref) < 1e-4
end

# Thread safety
# create an an abstract array type that doesn't allow setindex
struct ImmutableVector <: DenseVector{Float64}
    x::Vector{Float64}
end
Base.size(x::ImmutableVector) = size(x.x)
Base.getindex(x::ImmutableVector, i::Integer) = x.x[i]
@testset "thread safety" begin
    @testset "Gradients with diff type $difftype" for difftype in (Val{:forward}, Val{:central}, Val{:complex})
        g = FiniteDiff.finite_difference_gradient(sum, ImmutableVector(ones(2)), difftype)
        @test g ≈ ones(2)
        FiniteDiff.finite_difference_gradient!(g, sum, ImmutableVector(ones(2)), difftype)
        @test g ≈ ones(2)
    end

    @testset "Hessians (only supported diff type is :hcentral)" begin
        H = FiniteDiff.finite_difference_hessian(t -> sum(abs2, t) / 2, ImmutableVector(ones(2)))
        @test H ≈ Matrix(I, 2, 2)
        FiniteDiff.finite_difference_hessian!(parent(H), t -> sum(abs2, t) / 2, ImmutableVector(ones(2)))
        @test H ≈ Matrix(I, 2, 2)
    end

    @testset "Jacobians with diff type $difftype" for difftype in (Val{:forward}, Val{:central}, Val{:complex})
        J = FiniteDiff.finite_difference_jacobian(identity, ImmutableVector(ones(2)), difftype)
        @test J ≈ Matrix(I, 2, 2)
        FiniteDiff.finite_difference_jacobian!(J, (out, in) -> out .= in, ImmutableVector(ones(2)), difftype)
        @test J ≈ Matrix(I, 2, 2)
    end
end

@testset "Hessian Cache test" begin
    # https://github.com/JuliaDiff/FiniteDiff.jl/issues/185
    f(x) = sum(abs2, x)
    x1, x2 = float.(1:4), float.(5:8);
    @test FiniteDiff.finite_difference_hessian(f, x1, FiniteDiff.HessianCache(x1)) == Diagonal(2*ones(4))
    @test FiniteDiff.finite_difference_hessian(f, x1, FiniteDiff.HessianCache(x2)) == Diagonal(2*ones(4))
end

struct GradientCache{
    CacheType1, CacheType2, CacheType3, CacheType4, fdtype, returntype, inplace}
    fx::CacheType1
    c1::CacheType2
    c2::CacheType3
    c3::CacheType4
end

"""
    FiniteDiff.GradientCache(
        df         :: Union{<:Number,AbstractArray{<:Number}},
        x          :: Union{<:Number, AbstractArray{<:Number}},
        fdtype     :: Type{T1} = Val{:central},
        returntype :: Type{T2} = eltype(df),
        inplace    :: Type{Val{T3}} = Val{true})

Allocating Cache Constructor
"""
function GradientCache(
        df,
        x,
        fdtype = Val(:central),
        returntype = eltype(df),
        inplace = Val(true))
    fdtype isa Type && (fdtype = fdtype())
    inplace isa Type && (inplace = inplace())
    if typeof(x) <: AbstractArray # the vector->scalar case
        if fdtype != Val(:complex) # complex-mode FD only needs one cache, for x+eps*im
            if typeof(x) <: StridedVector
                if eltype(df) <: Complex && !(eltype(x) <: Complex)
                    _c1 = zero(Complex{eltype(x)}) .* x
                    _c2 = nothing
                else
                    _c1 = nothing
                    _c2 = nothing
                end
            else
                _c1 = zero(x)
                _c2 = zero(real(eltype(x))) .* x
            end
        else
            if !(returntype <: Real)
                fdtype_error(returntype)
            else
                _c1 = x .+ zero(eltype(x)) .* im
                _c2 = nothing
            end
        end
        _c3 = zero(x)
    else # the scalar->vector case
        # need cache arrays for fx1 and fx2, except in complex mode, which needs one complex array
        if fdtype != Val(:complex)
            _c1 = zero(df)
            _c2 = zero(df)
        else
            _c1 = zero(Complex{eltype(x)}) .* df
            _c2 = nothing
        end
        _c3 = x
    end

    GradientCache{Nothing, typeof(_c1), typeof(_c2), typeof(_c3), fdtype,
        returntype, inplace}(nothing, _c1, _c2, _c3)
end

"""
    FiniteDiff.GradientCache(
        fx         :: Union{Nothing,<:Number,AbstractArray{<:Number}},
        c1         :: Union{Nothing,AbstractArray{<:Number}},
        c2         :: Union{Nothing,AbstractArray{<:Number}},
        c3         :: Union{Nothing,AbstractArray{<:Number}},
        fdtype     :: Type{T1} = Val{:central},
        returntype :: Type{T2} = eltype(fx),
        inplace    :: Type{Val{T3}} = Val{true})

Non-Allocating Cache Constructor

# Arguments 
- `fx`: Cached function call.
- `c1`, `c2`, `c3`: (Non-aliased) caches for the input vector.
- `fdtype = Val(:central)`: Method for cmoputing the finite difference.
- `returntype = eltype(fx)`: Element type for the returned function value.
- `inplace = Val(false)`: Whether the function is computed in-place or not.

# Output 
The output is a [`GradientCache`](@ref) struct.

```julia-repl
julia> x = [1.0, 3.0]
2-element Vector{Float64}:
 1.0
 3.0

julia> _f = x -> x[1] + x[2]
#13 (generic function with 1 method)

julia> fx = _f(x)
4.0

julia> gradcache = GradientCache(copy(x), copy(x), copy(x), fx)
GradientCache{Float64, Vector{Float64}, Vector{Float64}, Vector{Float64}, Val{:central}(), Float64, Val{false}()}(4.0, [1.0, 3.0], [1.0, 3.0], [1.0, 3.0])
```
"""
function GradientCache(
        fx::Fx,# match order in struct for Setfield
        c1::T,
        c2::T,
        c3::T,
        fdtype = Val(:central),
        returntype = eltype(fx),
        inplace = Val(true)) where {T, Fx} # Val(false) isn't so important for vector -> scalar, it gets ignored in that case anyway.
    GradientCache{Fx, T, T, T, fdtype, returntype, inplace}(fx, c1, c2, c3)
end

"""
    FiniteDiff.finite_difference_gradient(
        f,
        x,
        fdtype     :: Type{T1}      = Val{:central},
        returntype :: Type{T2}      = eltype(x),
        inplace    :: Type{Val{T3}} = Val{true};
        relstep = default_relstep(fdtype, eltype(x)),
        absstep = relstep,
        dir     = true)

Compute the gradient of function `f` at point `x` using finite differences.

This is the cache-less version that allocates temporary arrays internally.
Supports both vector→scalar maps `f(x) → scalar` and scalar→vector maps depending
on the `inplace` parameter and function signature.

# Arguments
- `f`: Function to differentiate
  - If `typeof(x) <: AbstractArray`: `f(x)` should return a scalar (vector→scalar gradient)
  - If `typeof(x) <: Number` and `inplace=Val(true)`: `f(fx, x)` modifies `fx` in-place (scalar→vector gradient)
  - If `typeof(x) <: Number` and `inplace=Val(false)`: `f(x)` returns a vector (scalar→vector gradient)
- `x`: Point at which to evaluate the gradient (vector or scalar)
- `fdtype::Type{T1}=Val{:central}`: Finite difference method (`:forward`, `:central`, `:complex`)
- `returntype::Type{T2}=eltype(x)`: Element type of gradient components
- `inplace::Type{Val{T3}}=Val{true}`: Whether to use in-place function evaluation

# Keyword Arguments
- `relstep`: Relative step size (default: method-dependent optimal value)
- `absstep=relstep`: Absolute step size fallback
- `dir=true`: Direction for step size (typically ±1)

# Returns
- Gradient vector `∇f` where `∇f[i] = ∂f/∂x[i]`

# Examples
```julia
# Vector→scalar gradient
f(x) = x[1]^2 + x[2]^2
x = [1.0, 2.0]
grad = finite_difference_gradient(f, x)  # [2.0, 4.0]

# Scalar→vector gradient (out-of-place)
g(t) = [t^2, t^3]
t = 2.0
grad = finite_difference_gradient(g, t, Val(:central), eltype(t), Val(false))
```

# Notes
- Forward differences: `O(n)` function evaluations, `O(h)` accuracy
- Central differences: `O(2n)` function evaluations, `O(h²)` accuracy
- Complex step: `O(n)` function evaluations, machine precision accuracy
"""
function finite_difference_gradient(
        f,
        x,
        fdtype = Val(:central),
        returntype = eltype(x),
        inplace = Val(true),
        fx = nothing,
        c1 = nothing,
        c2 = nothing;
        relstep = default_relstep(fdtype, eltype(x)),
        absstep = relstep,
        dir = true)
    inplace isa Type && (inplace = inplace())
    if typeof(x) <: AbstractArray
        df = zero(returntype) .* x
    else
        if inplace == Val(true)
            if typeof(fx) == Nothing && typeof(c1) == Nothing && typeof(c2) == Nothing
                error("In the scalar->vector in-place map case, at least one of fx, c1 or c2 must be provided, otherwise we cannot infer the return size.")
            else
                if c1 != nothing
                    df = zero(c1)
                elseif fx != nothing
                    df = zero(fx)
                elseif c2 != nothing
                    df = zero(c2)
                end
            end
        else
            df = zero(f(x))
        end
    end
    cache = GradientCache(df, x, fdtype, returntype, inplace)
    finite_difference_gradient!(
        df, f, x, cache, relstep = relstep, absstep = absstep, dir = dir)
end

"""
    FiniteDiff.finite_difference_gradient!(
        df,
        f,
        x,
        fdtype::Type{T1}=Val{:central},
        returntype::Type{T2}=eltype(df),
        inplace::Type{Val{T3}}=Val{true};
        relstep=default_relstep(fdtype, eltype(x)),
        absstep=relstep)

Gradients are either a vector->scalar map `f(x)`, or a scalar->vector map `f(fx,x)` if `inplace=Val{true}` and `fx=f(x)` if `inplace=Val{false}`.

Cache-less.
"""
function finite_difference_gradient!(
        df,
        f,
        x,
        fdtype = Val(:central),
        returntype = eltype(df),
        inplace = Val(true),
        fx = nothing,
        c1 = nothing,
        c2 = nothing;
        relstep = default_relstep(fdtype, eltype(x)),
        absstep = relstep)
    cache = GradientCache(df, x, fdtype, returntype, inplace)
    finite_difference_gradient!(df, f, x, cache, relstep = relstep, absstep = absstep)
end

"""
    FiniteDiff.finite_difference_gradient!(
        df    :: AbstractArray{<:Number},
        f,
        x     :: AbstractArray{<:Number},
        cache :: GradientCache;
        relstep = default_relstep(fdtype, eltype(x)),
        absstep = relstep
        dir     = true)

Gradients are either a vector->scalar map `f(x)`, or a scalar->vector map `f(fx,x)` if `inplace=Val{true}` and `fx=f(x)` if `inplace=Val{false}`.

Cached.
"""
function finite_difference_gradient(
        f,
        x,
        cache::GradientCache{T1, T2, T3, T4, fdtype, returntype, inplace};
        relstep = default_relstep(fdtype, eltype(x)),
        absstep = relstep,
        dir = true) where {T1, T2, T3, T4, fdtype, returntype, inplace}
    if typeof(x) <: AbstractArray
        df = zero(returntype) .* x
        finite_difference_gradient!(
            df, f, x, cache, relstep = relstep, absstep = absstep, dir = dir)
        df
    else
        # Scalar x: compute out-of-place to support immutable output types
        # (e.g. ArrayPartition{SVector} from SecondOrderODEProblem).
        _scalar_gradient_oop(f, x, cache, fdtype, returntype, inplace;
            relstep = relstep, absstep = absstep, dir = dir)
    end
end

# Out-of-place scalar→vector gradient that never mutates the result,
# so it works even when f returns immutable arrays (SVector, etc.).
function _scalar_gradient_oop(
        f, x::Number, cache, fdtype, returntype, inplace;
        relstep, absstep, dir)
    fx, c1, c2 = cache.fx, cache.c1, cache.c2

    if fdtype == Val(:forward)
        epsilon = compute_epsilon(Val(:forward), x, relstep, absstep, dir)
        _c1 = inplace == Val(true) ? (f(c1, x + epsilon); c1) : f(x + epsilon)
        if typeof(fx) != Nothing
            @. (_c1 - fx) / epsilon
        else
            _c2 = inplace == Val(true) ? (f(c2, x); c2) : f(x)
            @. (_c1 - _c2) / epsilon
        end
    elseif fdtype == Val(:central)
        epsilon = compute_epsilon(Val(:central), x, relstep, absstep, dir)
        _c1 = inplace == Val(true) ? (f(c1, x + epsilon); c1) : f(x + epsilon)
        _c2 = inplace == Val(true) ? (f(c2, x - epsilon); c2) : f(x - epsilon)
        @. (_c1 - _c2) / (2 * epsilon)
    elseif fdtype == Val(:complex) && returntype <: Real
        epsilon_complex = eps(real(eltype(x)))
        _c1 = inplace == Val(true) ?
              (f(c1, x + im * epsilon_complex); c1) : f(x + im * epsilon_complex)
        @. imag(_c1) / epsilon_complex
    else
        fdtype_error(returntype)
    end
end

# vector of derivatives of a vector->scalar map by each component of a vector x
# this ignores the value of "inplace", because it doesn't make much sense
function finite_difference_gradient!(
        df,
        f,
        x,
        cache::GradientCache{T1, T2, T3, T4, fdtype, returntype, inplace};
        relstep = default_relstep(fdtype, eltype(x)),
        absstep = relstep,
        dir = true) where {T1, T2, T3, T4, fdtype, returntype, inplace}

    # NOTE: in this case epsilon is a vector, we need two arrays for epsilon and x1
    # c1 denotes x1, c2 is epsilon
    fx, c1, c2, c3 = cache.fx, cache.c1, cache.c2, cache.c3
    if fdtype != Val(:complex) && ArrayInterface.fast_scalar_indexing(c2)
        @. c2 = compute_epsilon(fdtype, one(eltype(x)), relstep, absstep, dir)
    end
    copyto!(c1, x)
    if fdtype == Val(:forward)
        @inbounds for i in eachindex(x)
            if ArrayInterface.fast_scalar_indexing(c2)
                epsilon = ArrayInterface.allowed_getindex(c2, i) * dir
            else
                epsilon = compute_epsilon(fdtype, one(eltype(x)), relstep, absstep, dir) *
                          dir
            end
            c1_old = ArrayInterface.allowed_getindex(c1, i)
            ArrayInterface.allowed_setindex!(c1, c1_old + epsilon, i)
            if typeof(fx) != Nothing
                dfi = (f(c1) - fx) / epsilon
            else
                fx0 = f(x)
                dfi = (f(c1) - fx0) / epsilon
            end
            df_tmp = real(dfi)
            if eltype(df) <: Complex
                ArrayInterface.allowed_setindex!(c1, c1_old + im * epsilon, i)
                if typeof(fx) != Nothing
                    dfi = (f(c1) - fx) / (im * epsilon)
                else
                    dfi = (f(c1) - fx0) / (im * epsilon)
                end
                ArrayInterface.allowed_setindex!(c1, c1_old, i)
                ArrayInterface.allowed_setindex!(df, df_tmp - im * imag(dfi), i)
            else
                ArrayInterface.allowed_setindex!(df, df_tmp, i)
                ArrayInterface.allowed_setindex!(c1, c1_old, i)
            end
        end
    elseif fdtype == Val(:central)
        copyto!(c3, x)
        @inbounds for i in eachindex(x)
            if ArrayInterface.fast_scalar_indexing(c2)
                epsilon = ArrayInterface.allowed_getindex(c2, i) * dir
            else
                epsilon = compute_epsilon(fdtype, one(eltype(x)), relstep, absstep, dir) *
                          dir
            end
            c1_old = ArrayInterface.allowed_getindex(c1, i)
            ArrayInterface.allowed_setindex!(c1, c1_old + epsilon, i)
            x_old = ArrayInterface.allowed_getindex(x, i)
            ArrayInterface.allowed_setindex!(c3, x_old - epsilon, i)
            df_tmp = real((f(c1) - f(c3)) / (2 * epsilon))
            if eltype(df) <: Complex
                ArrayInterface.allowed_setindex!(c1, c1_old + im * epsilon, i)
                ArrayInterface.allowed_setindex!(c3, x_old - im * epsilon, i)
                df_tmp2 = im * imag((f(c1) - f(c3)) / (2 * im * epsilon))
                ArrayInterface.allowed_setindex!(df, df_tmp - df_tmp2, i)
            else
                ArrayInterface.allowed_setindex!(df, df_tmp, i)
            end
            ArrayInterface.allowed_setindex!(c1, c1_old, i)
            ArrayInterface.allowed_setindex!(c3, x_old, i)
        end
    elseif fdtype == Val(:complex) && returntype <: Real
        # we use c1 here to avoid typing issues with x
        epsilon_complex = eps(real(eltype(x)))
        @inbounds for i in eachindex(x)
            c1_old = ArrayInterface.allowed_getindex(c1, i)
            ArrayInterface.allowed_setindex!(c1, c1_old + im * epsilon_complex, i)
            ArrayInterface.allowed_setindex!(df, imag(f(c1)) / epsilon_complex, i)
            ArrayInterface.allowed_setindex!(c1, c1_old, i)
        end
    else
        fdtype_error(returntype)
    end
    df
end

function finite_difference_gradient!(
        df::StridedVector{<:Number},
        f,
        x::StridedVector{<:Number},
        cache::GradientCache{T1, T2, T3, T4, fdtype, returntype, inplace};
        relstep = default_relstep(fdtype, eltype(x)),
        absstep = relstep,
        dir = true) where {T1, T2, T3, T4, fdtype, returntype, inplace}

    # c1 is x1 if we need a complex copy of x, otherwise Nothing
    # c2 is Nothing
    fx, c1, c2, c3 = cache.fx, cache.c1, cache.c2, cache.c3
    if fdtype != Val(:complex)
        if eltype(df) <: Complex && !(eltype(x) <: Complex)
            copyto!(c1, x)
        end
    end
    copyto!(c3, x)
    if fdtype == Val(:forward)
        fx0 = fx !== nothing ? fx : f(x)
        for i in eachindex(x)
            epsilon = compute_epsilon(fdtype, x[i], relstep, absstep, dir)
            x_old = x[i]
            c3[i] += epsilon
            dfi = (f(c3) - fx0) / epsilon
            c3[i] = x_old

            df[i] = real(dfi)
            if eltype(df) <: Complex
                if eltype(x) <: Complex
                    c3[i] += im * epsilon
                    dfi = (f(c3) - fx0) / (im * epsilon)
                    c3[i] = x_old
                else
                    c1[i] += im * epsilon
                    dfi = (f(c1) - fx0) / (im * epsilon)
                    c1[i] = x_old
                end
                df[i] -= im * imag(dfi)
            end
        end
    elseif fdtype == Val(:central)
        @inbounds for i in eachindex(x)
            epsilon = compute_epsilon(fdtype, x[i], relstep, absstep, dir)
            x_old = x[i]
            c3[i] += epsilon
            dfi = f(c3)
            c3[i] = x_old - epsilon
            dfi -= f(c3)
            c3[i] = x_old
            df[i] = real(dfi / (2 * epsilon))
            if eltype(df) <: Complex
                if eltype(x) <: Complex
                    c3[i] += im * epsilon
                    dfi = f(c3)
                    c3[i] = x_old - im * epsilon
                    dfi -= f(c3)
                    c3[i] = x_old
                else
                    c1[i] += im * epsilon
                    dfi = f(c1)
                    c1[i] = x_old - im * epsilon
                    dfi -= f(c1)
                    c1[i] = x_old
                end
                df[i] -= im * imag(dfi / (2 * im * epsilon))
            end
        end
    elseif fdtype == Val(:complex) && returntype <: Real && eltype(df) <: Real &&
           eltype(x) <: Real
        copyto!(c1, x)
        epsilon_complex = eps(real(eltype(x)))
        # we use c1 here to avoid typing issues with x
        @inbounds for i in eachindex(x)
            c1_old = c1[i]
            c1[i] += im * epsilon_complex
            df[i] = imag(f(c1)) / epsilon_complex
            c1[i] = c1_old
        end
    else
        fdtype_error(returntype)
    end
    df
end

# vector of derivatives of a scalar->vector map
# this is effectively a vector of partial derivatives, but we still call it a gradient
function finite_difference_gradient!(
        df,
        f,
        x::Number,
        cache::GradientCache{T1, T2, T3, T4, fdtype, returntype, inplace};
        relstep = default_relstep(fdtype, eltype(x)),
        absstep = relstep,
        dir = true) where {T1, T2, T3, T4, fdtype, returntype, inplace}

    # NOTE: in this case epsilon is a scalar, we need two arrays for fx1 and fx2
    # c1 denotes fx1, c2 is fx2, sizes guaranteed by the cache constructor
    fx, c1, c2 = cache.fx, cache.c1, cache.c2

    if inplace == Val(true)
        _c1, _c2 = c1, c2
    end

    if fdtype == Val(:forward)
        epsilon = compute_epsilon(Val(:forward), x, relstep, absstep, dir)
        if inplace == Val(true)
            f(c1, x + epsilon)
        else
            _c1 = f(x + epsilon)
        end
        if typeof(fx) != Nothing
            @. df = (_c1 - fx) / epsilon
        else
            if inplace == Val(true)
                f(c2, x)
            else
                _c2 = f(x)
            end
            @. df = (_c1 - _c2) / epsilon
        end
    elseif fdtype == Val(:central)
        epsilon = compute_epsilon(Val(:central), x, relstep, absstep, dir)
        if inplace == Val(true)
            f(c1, x + epsilon)
            f(c2, x - epsilon)
        else
            _c1 = f(x + epsilon)
            _c2 = f(x - epsilon)
        end
        @. df = (_c1 - _c2) / (2 * epsilon)
    elseif fdtype == Val(:complex) && returntype <: Real
        epsilon_complex = eps(real(eltype(x)))
        if inplace == Val(true)
            f(c1, x + im * epsilon_complex)
        else
            _c1 = f(x + im * epsilon_complex)
        end
        @. df = imag(_c1) / epsilon_complex
    else
        fdtype_error(returntype)
    end
    df
end

using OrdinaryDiffEq, OrdinaryDiffEqRosenbrock, ADTypes, ForwardDiff, LinearAlgebra, Test

const nknots = 10
const h = 1.0/(nknots+1)
x = range(0, step=h, length=nknots)
u0 = sin.(π*x)

@inline function f(du,u,p,t)
  du .= zero(eltype(u))
  u₃ = @view u[3:end]
  u₂ = @view u[2:end-1]
  u₁ = @view u[1:end-2]
  @. du[2:end-1] = p[1]*((u₃ - 2*u₂ + u₁)/(h^2.0))
  nothing
end

p_true = [0.42]
jac_proto = Tridiagonal(similar(u0,nknots-1), similar(u0), similar(u0, nknots-1))
prob = ODEProblem(ODEFunction(f,jac_prototype=jac_proto), u0, (0.0,1.0), p_true)
sol_true = solve(prob, Rodas4P(), saveat=0.1)

function loss(p)
  _prob = remake(prob, p=p)
  sol = solve(_prob, Rodas4P(autodiff=AutoFiniteDiff()), saveat=0.1)
  sum((sol .- sol_true).^2)
end
# Loose tolerance: this is a smoke test that FiniteDiff works through a
# Rosenbrock solver with a Tridiagonal jacobian prototype; the exact value
# drifts with solver internals across OrdinaryDiffEq releases.
@test ForwardDiff.gradient(loss, [1.0])[1] ≈ 0.665 atol=1e-2

using Pkg
using SafeTestsets
const LONGER_TESTS = false

const GROUP = get(ENV, "GROUP", "All")
const is_APPVEYOR = Sys.iswindows() && haskey(ENV,"APPVEYOR")

function activate_downstream_env()
    Pkg.activate("downstream")
    Pkg.develop(PackageSpec(path=dirname(@__DIR__)))
    Pkg.instantiate()
end

@time begin

if GROUP == "All" || GROUP == "Core"
  @time @safetestset "Public API Tests" begin include("public_api_tests.jl") end
  @time @safetestset "FiniteDiff Standard Tests" begin include("finitedifftests.jl") end
  @time @safetestset "Color Differentiation Tests" begin include("coloring_tests.jl") end
  @time @safetestset "JVP Accuracy Tests" begin include("jvp_accuracy_tests.jl") end
  @time @safetestset "Out of Place Tests" begin include("out_of_place_tests.jl") end
  @time @safetestset "Cache Reuse Safety Tests" begin include("cache_reuse_tests.jl") end
end

if GROUP == "All" || GROUP == "Downstream"
  activate_downstream_env()
  @time @safetestset "ODEs" begin
    import OrdinaryDiffEq
    @time @safetestset "OrdinaryDiffEq Tridiagonal" begin include("downstream/ordinarydiffeq_tridiagonal_solve.jl") end
  end
end

end

using FiniteDiff, LinearAlgebra, SparseArrays, StaticArrays, Test

# Tests for issue #213: caches must be safe to reuse at a new x, regardless of
# how their internal scratch fields (e.g. JacobianCache.x1) were initialized.
# The original symptom was DI building a JacobianCache from `similar(x)`
# (uninitialized) and getting junk Jacobians in :central mode.

const J_REF = [2.0 0.0; 0.0 3.0; 4.0 0.0]
foo_oop(x) = [2x[1], 3x[2], 4x[1]]
foo_iip!(y, x) = (y[1] = 2x[1]; y[2] = 3x[2]; y[3] = 4x[1]; y)

# A non-zero point where the bug becomes obvious — at zeros(2) the junk in x1
# cancels by symmetry on this affine function and hides the issue.
const X_TEST = [1.0, 2.0]

"""Build a JacobianCache whose scratch fields are explicitly poisoned with a
huge value, mimicking what happens when a caller hands FiniteDiff a cache
allocated via `similar(x)` (which gives uninitialized memory)."""
function poisoned_jcache(fdtype; x_template = X_TEST, y_template = foo_oop(X_TEST), poison = 1.0e10)
    x1 = fill(poison, length(x_template))
    fx = fill(poison, length(y_template))
    if fdtype === Val(:complex)
        FiniteDiff.JacobianCache(x1, fx, nothing, fdtype)
    else
        fx1 = fill(poison, length(y_template))
        FiniteDiff.JacobianCache(x1, fx, fx1, fdtype)
    end
end

@testset "Cache reuse safety (issue #213)" begin

@testset "JacobianCache out-of-place reuse" begin
    @testset "fresh cache reused at new x" for fdtype in (Val(:forward), Val(:central), Val(:complex))
        cache = FiniteDiff.JacobianCache(zeros(2), zeros(3), fdtype)
        # Exercise the cache once at x_old, then reuse at X_TEST.
        FiniteDiff.finite_difference_jacobian(foo_oop, zeros(2), cache)
        J = FiniteDiff.finite_difference_jacobian(foo_oop, X_TEST, cache)
        @test J ≈ J_REF atol=1e-6
    end

    @testset "cache built with garbage x1/fx ($(fdtype))" for fdtype in (Val(:forward), Val(:central), Val(:complex))
        cache = poisoned_jcache(fdtype)
        J = FiniteDiff.finite_difference_jacobian(foo_oop, X_TEST, cache)
        @test J ≈ J_REF atol=1e-6
    end

    @testset "cache built with garbage x1/fx + sparsity ($(fdtype))" for fdtype in (Val(:forward), Val(:central))
        spJ = sparse(J_REF)
        cache = poisoned_jcache(fdtype)
        J = FiniteDiff.finite_difference_jacobian(foo_oop, X_TEST, cache;
                                                   sparsity = spJ, jac_prototype = spJ)
        @test Matrix(J) ≈ J_REF atol=1e-6
    end
end

@testset "JacobianCache in-place reuse" begin
    @testset "fresh cache reused at new x ($(fdtype))" for fdtype in (Val(:forward), Val(:central), Val(:complex))
        cache = FiniteDiff.JacobianCache(zeros(2), zeros(3), fdtype)
        J = zeros(3, 2)
        FiniteDiff.finite_difference_jacobian!(J, foo_iip!, zeros(2), cache)
        fill!(J, 0)
        FiniteDiff.finite_difference_jacobian!(J, foo_iip!, X_TEST, cache)
        @test J ≈ J_REF atol=1e-6
    end

    @testset "cache built with garbage x1/fx ($(fdtype))" for fdtype in (Val(:forward), Val(:central), Val(:complex))
        cache = poisoned_jcache(fdtype)
        J = zeros(3, 2)
        FiniteDiff.finite_difference_jacobian!(J, foo_iip!, X_TEST, cache)
        @test J ≈ J_REF atol=1e-6
    end

    @testset "in-place :central must not mutate x (sparse path)" begin
        spJ = sparse(J_REF)
        cache = poisoned_jcache(Val(:central))
        J = zeros(3, 2)
        x = copy(X_TEST)
        x_orig = copy(x)
        FiniteDiff.finite_difference_jacobian!(J, foo_iip!, x, cache;
                                                sparsity = spJ, colorvec = 1:2)
        @test Matrix(J) ≈ J_REF atol=1e-6
        @test x == x_orig  # x should be restored / unmutated
    end
end

@testset "GradientCache reuse" begin
    # `:complex` requires an analytic function, so don't use abs2 here.
    g(x) = x[1]^2 + x[2]^2 + x[3]^2
    grad_ref = [2.0, 4.0, 6.0]
    x = [1.0, 2.0, 3.0]

    # Use the allocating constructor so buffer types are correct, then poison
    # any non-`nothing` buffer to simulate a stale cache.
    @testset "vector → scalar with poisoned cache ($(fdtype))" for fdtype in (Val(:forward), Val(:central), Val(:complex))
        df = zeros(3)
        cache = FiniteDiff.GradientCache(df, x, fdtype, Float64, Val(false))
        for fld in (:c1, :c2, :c3)
            buf = getfield(cache, fld)
            buf isa AbstractArray && fill!(buf, 1e10)
        end
        grad = zeros(3)
        FiniteDiff.finite_difference_gradient!(grad, g, x, cache)
        @test grad ≈ grad_ref atol=1e-5
    end

    @testset "fresh cache reused at new x ($(fdtype))" for fdtype in (Val(:forward), Val(:central))
        cache = FiniteDiff.GradientCache(zeros(3), zeros(3), fdtype)
        grad = zeros(3)
        FiniteDiff.finite_difference_gradient!(grad, g, zeros(3), cache)
        FiniteDiff.finite_difference_gradient!(grad, g, x, cache)
        @test grad ≈ grad_ref atol=1e-5
    end
end

@testset "JVPCache reuse" begin
    foo_iip!_3 = (y, x) -> (y[1] = 2x[1]; y[2] = 3x[2]; y[3] = 4x[1]; y)
    v = [1.0, 0.0]
    jvp_ref = J_REF * v

    @testset "garbage cache ($(fdtype))" for fdtype in (Val(:forward), Val(:central))
        x1 = fill(1e10, 2)
        fx1 = fill(1e10, 3)
        cache = FiniteDiff.JVPCache(x1, fx1, fdtype)
        jvp = zeros(3)
        FiniteDiff.finite_difference_jvp!(jvp, foo_iip!_3, X_TEST, v, cache)
        @test jvp ≈ jvp_ref atol=1e-6
    end
end

@testset "HessianCache reuse" begin
    h(x) = x[1]^2 + 2 * x[2]^2
    H_ref = [2.0 0.0; 0.0 4.0]

    xpp = fill(1e10, 2); xpm = fill(1e10, 2); xmp = fill(1e10, 2); xmm = fill(1e10, 2)
    cache = FiniteDiff.HessianCache(xpp, xpm, xmp, xmm, Val(:hcentral), Val(true))
    H = zeros(2, 2)
    FiniteDiff.finite_difference_hessian!(H, h, X_TEST, cache)
    @test H ≈ H_ref atol=1e-3
end

# Mirrors the failure mode from JuliaDiff/DifferentiationInterface.jl#983: a
# caller building a cache with `similar(x)` fields and then asking for a
# Jacobian via the non-allocating entry point.
@testset "DI-style similar() cache (issue #983 reproduction)" begin
    foo(x) = [2x[1], 3x[2], 4x[1]]
    y = foo(X_TEST)

    @testset "$(fdtype)" for fdtype in (Val(:forward), Val(:central), Val(:complex))
        x1 = similar(X_TEST)
        fx = similar(y)
        if fdtype === Val(:complex)
            cache = FiniteDiff.JacobianCache(x1, fx, nothing, fdtype)
        else
            fx1 = similar(y)
            cache = FiniteDiff.JacobianCache(x1, fx, fx1, fdtype)
        end
        J = FiniteDiff.finite_difference_jacobian(foo, X_TEST, cache)
        @test J ≈ J_REF atol=1e-6
    end
end

end  # outer testset

module FiniteDiffBandedMatricesExt

if isdefined(Base, :get_extension)
    using FiniteDiff: FiniteDiff, ArrayInterface
    using BandedMatrices: BandedMatrices
else
    using ..FiniteDiff: FiniteDiff, ArrayInterface
    using ..BandedMatrices: BandedMatrices
end

FiniteDiff._use_findstructralnz(::BandedMatrices.BandedMatrix) = false

@inline function FiniteDiff._colorediteration!(Jac::Union{BandedMatrices.BandedMatrix,Array},
                                    sparsity::BandedMatrices.BandedMatrix,
                                    rows_index,cols_index,vfx,colorvec,color_i,ncols)
    nrows = size(Jac,1)
    l,u = BandedMatrices.bandwidths(sparsity)
    #data = BandedMatrices.bandeddata(Jac)
    for col_index in max(1,1-l):min(ncols,ncols+u)
        if colorvec[col_index] == color_i
            for row_index in max(1,col_index-u):min(nrows,col_index+l)
                #data[u+row_index-col_index+1,col_index] = vfx[row_index]
                Jac[row_index,col_index]=vfx[row_index]
            end
        end
    end
end

end #module

module FiniteDiffSparseArraysExt

using SparseArrays
using FiniteDiff

# jacobians.jl
function FiniteDiff._make_Ji(::SparseMatrixCSC, rows_index, cols_index, dx, colorvec, color_i, nrows, ncols)
    pick_inds = [i for i in 1:length(rows_index) if colorvec[cols_index[i]] == color_i]
    rows_index_c = rows_index[pick_inds]
    cols_index_c = cols_index[pick_inds]
    Ji = sparse(rows_index_c, cols_index_c, dx[rows_index_c], nrows, ncols)
    Ji
end

function FiniteDiff._make_Ji(::SparseMatrixCSC, xtype, dx, color_i, nrows, ncols)
    Ji = sparse(1:nrows, fill(color_i, nrows), dx, nrows, ncols)
    Ji
end

@inline function FiniteDiff._colorediteration!(J, sparsity::SparseMatrixCSC, rows_index, cols_index, vfx, colorvec, color_i, ncols)
    for col_index in 1:ncols
        if colorvec[col_index] == color_i
            for row_index in view(sparsity.rowval, sparsity.colptr[col_index]:sparsity.colptr[col_index+1]-1)
                J[row_index, col_index] = vfx[row_index]
            end
        end
    end
end

@inline FiniteDiff.fill_matrix!(J::AbstractSparseMatrix, v) = fill!(nonzeros(J), v)

@inline function FiniteDiff.fast_jacobian_setindex!(J::AbstractSparseMatrix, rows_index, cols_index, _color, color_i, vfx)
    @. FiniteDiff.void_setindex!((J.nzval,), getindex((J.nzval,), rows_index) + (getindex((_color,), cols_index) == color_i) * getindex((vfx,), rows_index), rows_index)
end

# iteration_utils.jl
## fast version for the case where J and sparsity have the same sparsity pattern
@inline function FiniteDiff._colorediteration!(Jsparsity::SparseMatrixCSC, vfx, colorvec, color_i, ncols)
    for col_index in 1:ncols
        if colorvec[col_index] == color_i
            for spidx in nzrange(Jsparsity, col_index)
                row_index = Jsparsity.rowval[spidx]
                Jsparsity.nzval[spidx] = vfx[row_index]
            end
        end
    end
end

FiniteDiff._use_findstructralnz(::SparseMatrixCSC) = false

FiniteDiff._use_sparseCSC_common_sparsity(J::SparseMatrixCSC, sparsity::SparseMatrixCSC) =
    ((J.colptr == sparsity.colptr) && (J.rowval == sparsity.rowval))


end

using FiniteDiff, LinearAlgebra, SparseArrays, Test, StaticArrays

function f(x)
  xm1 = [0;x[1:end-1]]
  xp1 = [x[2:end];0]
  xm1 - 2x + xp1
end

function second_derivative_stencil(N)
  A = zeros(N,N)
  for i in 1:N, j in 1:N
      (j-i==-1 || j-i==1) && (A[i,j]=1)
      j-i==0 && (A[i,j]=-2)
  end
  A
end

x = @SVector ones(30)
J = FiniteDiff.finite_difference_jacobian(f, x, Val{:forward}, eltype(x))
@test J ≈ second_derivative_stencil(30)

J = FiniteDiff.finite_difference_jacobian(f, x, Val{:central}, eltype(x))
@test J ≈ second_derivative_stencil(30)

J = FiniteDiff.finite_difference_jacobian(f, x, Val{:complex}, eltype(x))
@test J ≈ second_derivative_stencil(30)

spJ = sparse(second_derivative_stencil(30))
J = FiniteDiff.finite_difference_jacobian(f, x, Val{:forward}, eltype(x), jac_prototype=spJ)
@test J ≈ second_derivative_stencil(30)
@test typeof(J) == typeof(spJ)
J = FiniteDiff.finite_difference_jacobian(f, x, Val{:forward}, eltype(x),
    colorvec=SVector{30}(repeat(1:3, 10)), sparsity=spJ, jac_prototype=spJ)
@test J ≈ second_derivative_stencil(30)
@test typeof(J) == typeof(spJ)

f(x) = x
@testset "1x1 test of $x" for
  (x, y) in ((SVector{1}([1.]), SMatrix{1,1}), ([1.0], Matrix)),
    difftype in (:forward, :central, :complex)

  J = FiniteDiff.finite_difference_jacobian(f, x, Val{difftype}, eltype(x))
  @test J[1, 1] ≈ 1.0
  @test J isa y
end

x = SVector{1}([1.])
f(x) = vcat(x, x)
J = FiniteDiff.finite_difference_jacobian(f, x, Val{:forward}, eltype(x))
@test J ≈ fill(1.0, 2, 1)
@test J isa SMatrix{2,1}
J = FiniteDiff.finite_difference_jacobian(f, x, Val{:central}, eltype(x))
@test J ≈ fill(1.0, 2, 1)
@test J isa SMatrix{2,1}
J = FiniteDiff.finite_difference_jacobian(f, x, Val{:complex}, eltype(x))
@test J ≈ fill(1.0, 2, 1)
@test J isa SMatrix{2,1}

# The per-color closures used to assign variables that also live in the enclosing
# function's scope, which boxed the captures and made the return type `Any`.
# Static-array inputs stay uninferrable here: the `mapreduce(_, hcat, _)` accumulator
# grows one `SMatrix` column per color, so its type depends on `maximum(colorvec)`.
@testset "Type stability of the dense out-of-place jacobian" begin
  g(x) = x .^ 2 .- 2
  x = [1.0, 2.0, 3.0]
  @testset "$difftype" for difftype in (:forward, :central, :complex)
    cache = FiniteDiff.JacobianCache(x, Val{difftype}, eltype(x))
    @test (@inferred FiniteDiff.finite_difference_jacobian(g, x, cache)) ≈
      Diagonal(2x)
  end
end

using FiniteDiff, LinearAlgebra, SparseArrays, Test, LinearAlgebra,
  BlockBandedMatrices, ArrayInterface, BandedMatrices

fcalls = 0
function f(dx, x)
  global fcalls += 1
  for i in 2:length(x)-1
    dx[i] = x[i-1] - 2x[i] + x[i+1]
  end
  dx[1] = -2x[1] + x[2]
  dx[end] = x[end-1] - 2x[end]
  nothing
end
function oopf(x)
  global fcalls += 1
  vcat([-2x[1] + x[2]], [x[i-1] - 2x[i] + x[i+1] for i in 2:length(x)-1], [x[end-1] - 2x[end]])
end

function second_derivative_stencil(N)
  A = zeros(N, N)
  for i in 1:N, j in 1:N
    (j - i == -1 || j - i == 1) && (A[i, j] = 1)
    j - i == 0 && (A[i, j] = -2)
  end
  A
end

J = FiniteDiff.finite_difference_jacobian(oopf, rand(30))
@test J ≈ second_derivative_stencil(30)
_J = sparse(J)
@test fcalls == 31

_J2 = similar(_J)
fcalls = 0
FiniteDiff.finite_difference_jacobian!(_J2, f, rand(30), colorvec=repeat(1:3, 10))
@test fcalls == 4
@test _J2 ≈ _J

_J2 = similar(_J)
fcalls = 0
FiniteDiff.finite_difference_jacobian!(_J2, f, rand(30), Val{:central}, colorvec=repeat(1:3, 10))
@test fcalls == 6
@test _J2 ≈ _J

_J2 = similar(_J)
fcalls = 0
FiniteDiff.finite_difference_jacobian!(_J2, f, rand(30), Val{:complex}, colorvec=repeat(1:3, 10))
@test fcalls == 3
@test _J2 ≈ _J

_J2 = similar(_J)
_denseJ2 = collect(_J2)
fcalls = 0
FiniteDiff.finite_difference_jacobian!(_denseJ2, f, rand(30), colorvec=repeat(1:3, 10), sparsity=_J2)
@test fcalls == 4
@test sparse(_denseJ2) ≈ _J

_J2 = similar(_J)
_denseJ2 = collect(_J2)
fcalls = 0
FiniteDiff.finite_difference_jacobian!(_denseJ2, f, rand(30), Val{:central}, colorvec=repeat(1:3, 10), sparsity=_J2)
@test fcalls == 6
@test sparse(_denseJ2) ≈ _J

_J2 = similar(_J)
_denseJ2 = collect(_J2)
fcalls = 0
FiniteDiff.finite_difference_jacobian!(_denseJ2, f, rand(30), Val{:complex}, colorvec=repeat(1:3, 10), sparsity=_J2)
@test fcalls == 3
@test sparse(_denseJ2) ≈ _J

_J2 = similar(Tridiagonal(_J))
fcalls = 0
FiniteDiff.finite_difference_jacobian!(_J2, f, rand(30), colorvec=repeat(1:3, 10))
@test fcalls == 4
@test _J2 ≈ _J

_J2 = similar(_J2)
fcalls = 0
FiniteDiff.finite_difference_jacobian!(_J2, f, rand(30), Val{:central}, colorvec=repeat(1:3, 10))
@test fcalls == 6
@test _J2 ≈ _J

_J2 = similar(_J2)
fcalls = 0
FiniteDiff.finite_difference_jacobian!(_J2, f, rand(30), Val{:complex}, colorvec=repeat(1:3, 10))
@test fcalls == 3
@test _J2 ≈ _J

_Jb = BandedMatrices.BandedMatrix(similar(_J2), (1, 1))
FiniteDiff.finite_difference_jacobian!(_Jb, f, rand(30), colorvec=repeat(1:3, 10))
@test _Jb ≈ _J

_Jtri = Tridiagonal(similar(_J2))
FiniteDiff.finite_difference_jacobian!(_Jtri, f, rand(30), colorvec=repeat(1:3, 10))
@test _Jtri ≈ _J

#https://github.com/JuliaDiff/FiniteDiff.jl/issues/67#issuecomment-516871956
function f(out, x)
  x = reshape(x, 100, 100)
  out = reshape(out, 100, 100)
  for i in 1:100
    for j in 1:100
      out[i, j] = x[i, j] + x[max(i - 1, 1), j] + x[min(i + 1, size(x, 1)), j] + x[i, max(j - 1, 1)] + x[i, min(j + 1, size(x, 2))]
    end
  end
  return vec(out)
end
x = rand(10000)
Jbbb = BandedBlockBandedMatrix(Ones(10000, 10000), fill(100, 100), fill(100, 100), (1, 1), (1, 1))
Jsparse = sparse(Jbbb)
colorsbbb = ArrayInterface.matrix_colors(Jbbb)
FiniteDiff.finite_difference_jacobian!(Jbbb, f, x, colorvec=colorsbbb)
FiniteDiff.finite_difference_jacobian!(Jsparse, f, x, colorvec=colorsbbb)
@test Jbbb ≈ Jsparse
Jbb = BlockBandedMatrix(similar(Jsparse), fill(100, 100), fill(100, 100), (1, 1));
colorsbb = ArrayInterface.matrix_colors(Jbb)
FiniteDiff.finite_difference_jacobian!(Jbb, f, x, colorvec=colorsbb)
@test Jbb ≈ Jsparse


# Non-square Jacobian test.
# The Jacobian of f_nonsquare! has size (n, 2*n).
function f_nonsquare!(y, x)
  global fcalls += 1
  @assert length(x) == 2 * length(y)
  n = length(x) ÷ 2
  x1 = @view x[1:n]
  x2 = @view x[n+1:end]

  @. y = (x1 .- 3) .^ 2 .+ x1 .* x2 .+ (x2 .+ 4) .^ 2 .- 3
  return nothing
end

n = 4
x0 = vcat(ones(n) .* (1:n) .+ 0.5, ones(n) .* (1:n) .+ 1.5)
y0 = zeros(n)
rows = vcat([i for i in 1:n], [i for i in 1:n])
cols = vcat([i for i in 1:n], [i + n for i in 1:n])
sparsity = sparse(rows, cols, ones(length(rows)))
colorvec = vcat(fill(1, n), fill(2, n))

J_nonsquare1 = zeros(size(sparsity))
FiniteDiff.finite_difference_jacobian!(J_nonsquare1, f_nonsquare!, x0)

J_nonsquare2 = similar(sparsity)
for method in [Val(:forward), Val(:central), Val(:complex)]
  cache = FiniteDiff.JacobianCache(copy(x0), copy(y0), copy(y0), method; sparsity, colorvec)
  global fcalls = 0
  FiniteDiff.finite_difference_jacobian!(J_nonsquare2, f_nonsquare!, x0, cache)
  if method == Val(:central)
    @test fcalls == 2 * maximum(colorvec)
  elseif method == Val(:complex)
    @test fcalls == maximum(colorvec)
  else
    @test fcalls == maximum(colorvec) + 1
  end
  @test isapprox(J_nonsquare2, J_nonsquare1; rtol=1e-6)
end

## Non-sparse prototype 
# Test structralnz for dense matrix 
A = [[1 1; 0 1], [1 1 1], [1.0 1.0; 1.0 1.0; 1.0 1.0], [true true; true true]]
for a in A
  rows_index, cols_index = FiniteDiff._findstructralnz(a)
  rows_index2, cols_index2 = ArrayInterface.findstructralnz(sparse(a))
  @test (rows_index, cols_index) == (rows_index2, cols_index2)
end

# Square Jacobian
function _f(dx, x)
  dx .= [x[1]^2 + x[2]^2, x[1] + x[2]]
end
J = zeros(2, 2)
θ = [5.0, 3.0]
y0 = [0.0, 0.0]
cache = FiniteDiff.JacobianCache(copy(θ), copy(y0), copy(y0), Val(:forward); sparsity=[1 1; 1 1])
FiniteDiff.finite_difference_jacobian!(J, _f, θ, cache)
@test J ≈ [10 6; 1 1]

function _f2(dx, x)
  dx .= [x[1]^2 + x[2]^2, x[1]]
end
J = zeros(2, 2)
θ = [-3.0, 2.0]
y0 = [0.0, 0.0]
cache = FiniteDiff.JacobianCache(copy(θ), copy(y0), copy(y0), Val(:forward); sparsity=[1 1; 1 0])
FiniteDiff.finite_difference_jacobian!(J, _f2, θ, cache)
@test J ≈ [-6 4; 1 0]

# Rectangular Jacobian 
function _f3(dx, x)
  dx .= [x[1]^2 + x[2]^2 - x[1]]
end
J = zeros(1, 2)
θ = [-3.0, 2.0]
y0 = [0.0, 0.0]
cache = FiniteDiff.JacobianCache(copy(θ), copy(y0), copy(y0), Val(:forward); sparsity=[1 1])
FiniteDiff.finite_difference_jacobian!(J, _f3, θ, cache)
@test J ≈ [-7 4]

function _f4(dx, x)
  dx .= [x[1]^2 + x[2]^2 - x[1]; x[1]*x[2]; x[1]*x[3]; x[1]]
end
J = zeros(4, 3)
θ = [-3.0, 2.0, 13.3]
y0 = [0.0, 0.0, 0.0, 0.0]
cache = FiniteDiff.JacobianCache(copy(θ), copy(y0), copy(y0), Val(:forward); sparsity=[1 1 0; 1 1 0; 1 0 1; 1 0 0])
FiniteDiff.finite_difference_jacobian!(J, _f4, θ, cache)
@test J ≈ [-7.0 4.0 0; 2.0 -3.0 0.0; 13.3 0.0 -3.0; 1.0 0.0 0.0]

function _f5(dx, x)
    dx .= [x[1]^2 + x[2]^2]
end
J = zeros(1, 2)
θ = [5.0, 3.0]
y0 = [0.0]
cache = FiniteDiff.JacobianCache(copy(θ), copy(y0), copy(y0), Val(:forward); sparsity = [1 1])
FiniteDiff.finite_difference_jacobian!(J, _f5, θ, cache)
@test J ≈ [10.0 6.0]

"""
    FiniteDiff

Fast non-allocating calculations of gradients, Jacobians, and Hessians with sparsity support.
"""
module FiniteDiff

using LinearAlgebra, ArrayInterface

import Base: resize!

"""
    _vec(x)

Internal utility function to vectorize arrays while preserving scalars.

# Arguments
- `x`: Array or scalar

# Returns
- `vec(x)` for arrays, `x` unchanged for scalars
"""
_vec(x) = vec(x)
_vec(x::Number) = x

"""
    _mat(x)

Internal utility function to ensure matrix format.

Converts vectors to column matrices while preserving existing matrices.
Used internally to ensure consistent matrix dimensions for operations.

# Arguments  
- `x`: Matrix or vector

# Returns
- `x` unchanged if already a matrix
- Reshaped column matrix if `x` is a vector
"""
_mat(x::AbstractMatrix) = x
_mat(x::AbstractVector) = reshape(x, (axes(x, 1), Base.OneTo(1)))

# Setindex overloads without piracy
setindex(x...) = Base.setindex(x...)

"""
    setindex(x::AbstractArray, v, i...)

Non-mutating setindex operation that returns a copy with modified elements.

Creates a mutable copy of array `x`, sets the specified indices to value `v`,
and returns the modified copy. This avoids type piracy while providing 
setindex functionality for immutable arrays.

# Arguments
- `x::AbstractArray`: Array to modify (not mutated)
- `v`: Value to set at the specified indices
- `i...`: Indices where the value should be set

# Returns
- Modified copy of `x` with `x[i...] = v`

# Examples
```julia
x = [1, 2, 3]
y = setindex(x, 99, 2)  # y = [1, 99, 3], x unchanged
```
"""
function setindex(x::AbstractArray, v, i...)
    _x = Base.copymutable(x)
    _x[i...] = v
    return _x
end

"""
    setindex(x::AbstractVector, v, i::Int)

Broadcasted setindex operation for vectors using boolean masking.

Sets the i-th element of vector `x` to value `v` using broadcasting operations.
This implementation uses boolean masks to avoid explicit copying and provide
efficient vectorized operations.

# Arguments
- `x::AbstractVector`: Input vector  
- `v`: Value to set at index `i`
- `i::Int`: Index to modify

# Returns
- Vector with `x[i] = v`, computed via broadcasting

# Examples
```julia
x = [1.0, 2.0, 3.0]
y = setindex(x, 99.0, 2)  # [1.0, 99.0, 3.0]
```
"""
function setindex(x::AbstractVector, v, i::Int)
    n = length(x)
    x .* (i .!== 1:n) .+ v .* (i .== 1:n)
end

"""
    setindex(x::AbstractMatrix, v, i::Int, j::Int)

Broadcasted setindex operation for matrices using boolean masking.

Sets the (i,j)-th element of matrix `x` to value `v` using broadcasting operations.
This implementation uses boolean masks to avoid explicit copying and provide
efficient vectorized operations.

# Arguments
- `x::AbstractMatrix`: Input matrix
- `v`: Value to set at position (i,j)
- `i::Int`: Row index to modify
- `j::Int`: Column index to modify

# Returns
- Matrix with `x[i,j] = v`, computed via broadcasting

# Examples
```julia
x = [1.0 2.0; 3.0 4.0]
y = setindex(x, 99.0, 1, 2)  # [1.0 99.0; 3.0 4.0]
```

# Notes
The implementation uses transposed broadcasting `(j .!== i:m)'` which appears
to be a typo - should likely be `(j .!== 1:m)'` for correct column masking.
"""
function setindex(x::AbstractMatrix, v, i::Int, j::Int)
    n, m = Base.size(x)
    x .* (i .!== 1:n) .* (j .!== i:m)' .+ v .* (i .== 1:n) .* (j .== i:m)'
end

include("iteration_utils.jl")
include("epsilons.jl")
include("derivatives.jl")
include("gradients.jl")
include("jacobians.jl")
include("hessians.jl")
include("jvp.jl")

# Mark the documented user-facing API (the names rendered in the docs' `@docs`
# blocks) as public. `public` is a keyword only on Julia 1.11+, so it is emitted
# via `eval` guarded on the version to keep this source parseable on the 1.10 LTS.
@static if VERSION >= v"1.11.0-DEV.469"
    eval(Expr(:public,
        :finite_difference_derivative, :finite_difference_derivative!,
        :finite_difference_gradient, :finite_difference_gradient!,
        :finite_difference_jacobian, :finite_difference_jacobian!,
        :finite_difference_hessian, :finite_difference_hessian!,
        :finite_difference_jvp, :finite_difference_jvp!,
        :DerivativeCache, :GradientCache, :JacobianCache, :HessianCache, :JVPCache))
end

end # module

"""
    _colorediteration!(J, sparsity, rows_index, cols_index, vfx, colorvec, color_i, ncols)

Internal function for sparse Jacobian assembly using graph coloring.

Updates the Jacobian matrix `J` with finite difference values for columns 
belonging to the current color group. This is part of the graph-coloring 
algorithm that computes multiple Jacobian columns simultaneously.

# Arguments
- `J`: Jacobian matrix to update (modified in-place)
- `sparsity`: Sparsity pattern of the Jacobian
- `rows_index`: Row indices of non-zero elements
- `cols_index`: Column indices of non-zero elements
- `vfx`: Vector of computed finite difference values
- `colorvec`: Vector assigning colors to columns
- `color_i`: Current color being processed
- `ncols`: Total number of columns in the Jacobian

# Notes
This function implements the core loop of the graph-coloring sparse Jacobian
algorithm. It assigns finite difference values to the appropriate entries
in the Jacobian matrix for all columns sharing the same color.
"""
@inline function _colorediteration!(
        J, sparsity, rows_index, cols_index, vfx, colorvec, color_i, ncols)
    for i in 1:length(cols_index)
        if colorvec[cols_index[i]] == color_i
            J[rows_index[i], cols_index[i]] = vfx[rows_index[i]]
        end
    end
end

"""
    _use_findstructralnz(sparsity)

Internal function to determine whether to use `findstructralnz` for sparsity detection.

Returns `true` if the sparsity pattern has structural information that can be 
utilized by `findstructralnz`, `false` otherwise. This overrides the default
behavior and delegates to `ArrayInterface.has_sparsestruct`.

# Arguments
- `sparsity`: Sparsity pattern object

# Returns
- `true` if structural sparsity information is available, `false` otherwise
"""
_use_findstructralnz(sparsity) = ArrayInterface.has_sparsestruct(sparsity)

"""
    _use_sparseCSC_common_sparsity(J, sparsity)

Internal function to test for common sparsity patterns between Jacobian and sparsity matrix.

Tests if both `J` and `sparsity` are `SparseMatrixCSC` matrices with the same 
sparsity pattern of stored values. Currently always returns `false` as a 
conservative default.

# Arguments
- `J`: Jacobian matrix
- `sparsity`: Sparsity pattern matrix

# Returns
- `false` (conservative default - may be optimized in the future)

# Notes
This function could be optimized to return `true` when both matrices have
identical sparsity patterns, allowing for more efficient algorithms.
"""
_use_sparseCSC_common_sparsity(J, sparsity) = false

module FiniteDiffBlockBandedMatricesExt

if isdefined(Base, :get_extension)
    using FiniteDiff: FiniteDiff, ArrayInterface
    using BlockBandedMatrices: BlockBandedMatrices
    using BlockBandedMatrices.BlockArrays
else
    using ..FiniteDiff: FiniteDiff, ArrayInterface
    using ..BlockBandedMatrices: BlockBandedMatrices
    using ..BlockBandedMatrices.BlockArrays
end

FiniteDiff._use_findstructralnz(::BlockBandedMatrices.BandedBlockBandedMatrix) = false
FiniteDiff._use_findstructralnz(::BlockBandedMatrices.BlockBandedMatrix) = false

@inline function FiniteDiff._colorediteration!(Jac::BlockBandedMatrices.BandedBlockBandedMatrix,
                                    sparsity::BlockBandedMatrices.BandedBlockBandedMatrix,
                                    rows_index,cols_index,vfx,colorvec,color_i,ncols)
    λ,μ = BlockBandedMatrices.subblockbandwidths(Jac)
    rs = BlockArrays.blocklengths(BlockArrays.axes(Jac,1)) # column block sizes
    cs = BlockArrays.blocklengths(BlockArrays.axes(Jac,1))
    b = BlockBandedMatrices.BlockArray(vfx,rs)
    c = BlockBandedMatrices.BlockArray(colorvec,cs)
    for J=BlockArrays.blockaxes(Jac,2)
        c_v = c.blocks[J.n[1]]
        for K=BlockBandedMatrices.blockcolrange(Jac,J)
            V = view(Jac,K,J)
            b_v = b.blocks[K.n[1]]
            data = BlockBandedMatrices.bandeddata(V)
            p = pointer(data)
            st = stride(data,2)
            m,n = size(V)
            for j=1:n
                if c_v[j] == color_i
                    for k=max(1,j-μ):min(m,j+λ)
                        unsafe_store!(p, b_v[k], (j-1)*st + μ + k - j + 1)
                    end
                end
            end
        end
    end
end

@inline function FiniteDiff._colorediteration!(Jac::BlockBandedMatrices.BlockBandedMatrix,
                                    sparsity::BlockBandedMatrices.BlockBandedMatrix,
                                    rows_index,cols_index,vfx,colorvec,color_i,ncols)
    rs = BlockArrays.blocklengths(BlockArrays.axes(Jac,1)) # column block sizes
    cs = BlockArrays.blocklengths(BlockArrays.axes(Jac,1))
    b = BlockBandedMatrices.BlockArray(vfx,rs)
    c = BlockBandedMatrices.BlockArray(colorvec,cs)
    for J=BlockArrays.blockaxes(Jac,2)
        c_v = c.blocks[J.n[1]]
        blockcolrange = BlockBandedMatrices.blockcolrange(Jac,J)
        _,n = length.(getindex.(axes(Jac), (blockcolrange[1], J)))
        for j = 1:n
            if c_v[j] == color_i
                for K = blockcolrange
                    V = view(Jac,K,J)
                    b_v = b.blocks[K.n[1]]
                    m = size(V,1)
                    for k = 1:m
                        V[k,j] = b_v[k]
                    end
                end
            end
        end
    end
end


end #module

using FiniteDiff, Test

# The documented user-facing API: every name rendered in a `@docs` block in the
# manual. These must be reachable and, on Julia 1.11+, marked `public` so that
# downstream packages' ExplicitImports/Aqua qualified-access checks pass.
const PUBLIC_API = (
    :finite_difference_derivative, :finite_difference_derivative!,
    :finite_difference_gradient, :finite_difference_gradient!,
    :finite_difference_jacobian, :finite_difference_jacobian!,
    :finite_difference_hessian, :finite_difference_hessian!,
    :finite_difference_jvp, :finite_difference_jvp!,
    :DerivativeCache, :GradientCache, :JacobianCache, :HessianCache, :JVPCache,
)

@testset "Public API is defined" begin
    for name in PUBLIC_API
        @test isdefined(FiniteDiff, name)
    end
end

@static if VERSION >= v"1.11.0-DEV.469"
    @testset "Public API is marked public" begin
        for name in PUBLIC_API
            @test Base.ispublic(FiniteDiff, name)
        end
    end
end

# Internal Utilities

Internal utility functions and algorithms used throughout FiniteDiff.jl. These functions are primarily for advanced users who need to understand or extend the library's functionality.

## Array Utilities

Internal utilities for handling different array types and ensuring compatibility across the Julia ecosystem:

### Type Conversion Functions

These functions help FiniteDiff.jl work with various array types including `StaticArrays`, structured matrices, and GPU arrays:

- **`_vec(x)`**: Vectorizes arrays while preserving scalars unchanged
- **`_mat(x)`**: Ensures matrix format, converting vectors to column matrices  
- **`setindex(x, v, i...)`**: Non-mutating setindex operations for immutable arrays

### Hessian Utilities

Helper functions specifically for Hessian computation:

- **`_hessian_inplace(x)`**: Determines whether to use in-place operations based on array mutability
- **`__Symmetric(x)`**: Wraps matrices in `Symmetric` views for mathematical correctness
- **`mutable_zeromatrix(x)`**: Creates mutable zero matrices compatible with input arrays

## Sparse Jacobian Internals

Graph coloring and sparse matrix algorithms for efficient Jacobian computation:

### Matrix Construction

- **`_make_Ji(...)`**: Constructs Jacobian contribution matrices for both sparse and dense cases
- **`_colorediteration!(...)`**: Core loop for sparse Jacobian assembly using graph coloring
- **`_findstructralnz(A)`**: Finds structural non-zero patterns in dense matrices

### Sparsity Detection

- **`_use_findstructralnz(sparsity)`**: Determines when to use structural sparsity information
- **`_use_sparseCSC_common_sparsity(J, sparsity)`**: Tests for common sparsity patterns between matrices

### Performance Optimizations

- **`fast_jacobian_setindex!(...)`**: Optimized index operations for sparse Jacobian assembly
- **`void_setindex!(...)`**: Wrapper for setindex operations that discards return values

## JVP Utilities

- **`resize!(cache::JVPCache, i)`**: Resizes JVP cache arrays for dynamic problems
- **`resize!(cache::JacobianCache, i)`**: Resizes Jacobian cache arrays for dynamic problems

## Error Handling

- **`fdtype_error(::Type{T})`**: Provides informative error messages for unsupported finite difference type combinations

## Design Philosophy

These internal utilities follow several design principles:

1. **Type Stability**: All functions are designed for type-stable operations
2. **Zero Allocation**: Internal utilities avoid allocations when possible
3. **Genericity**: Support for multiple array types (dense, sparse, static, GPU)
4. **Performance**: Optimized for the specific needs of finite difference computation
5. **Safety**: Proper error handling and bounds checking where needed

## Advanced Usage

These functions are primarily internal, but advanced users may find them useful for:

- **Custom finite difference implementations**
- **Integration with other differentiation libraries**  
- **Performance optimization in specialized applications**
- **Understanding the implementation details of FiniteDiff.jl**

Most users should rely on the main API functions rather than calling these utilities directly.

# Jacobians

Functions for computing Jacobian matrices of vector-valued functions.

## Function Types

Jacobians support the following function signatures:

- **Out-of-place**: `fx = f(x)` where both `x` and `fx` are vectors
- **In-place**: `f!(fx, x)` where `f!` modifies `fx` in-place

## Sparse Jacobians

FiniteDiff.jl provides efficient sparse Jacobian computation using graph coloring:

- Pass a `colorvec` of matrix colors to enable column compression
- Provide `sparsity` as a sparse (e.g. the default `SparseMatrixCSC`) 
  or structured matrix (`Tridiagonal`, `Banded`, etc.)
- Supports automatic sparsity pattern detection via ArrayInterfaceCore.jl
- Results are automatically decompressed unless `sparsity=nothing`

## Performance Notes

- **Forward differences**: `O(n)` function evaluations, `O(h)` accuracy  
- **Central differences**: `O(2n)` function evaluations, `O(h²)` accuracy
- **Complex step**: `O(n)` function evaluations, machine precision accuracy
- **Sparse Jacobians**: Use graph coloring to reduce function evaluations significantly

For non-square Jacobians, specify the output vector `fx` when creating the cache to ensure proper sizing.

## Functions

```@docs
FiniteDiff.finite_difference_jacobian
FiniteDiff.finite_difference_jacobian!
```

## Cache

```@docs
FiniteDiff.JacobianCache
```

# Step Size Selection (Epsilons)

Functions and theory for computing optimal step sizes in finite difference approximations.

## Theory

The choice of step size (epsilon) in finite difference methods is critical for accuracy. Too large a step leads to truncation error, while too small a step leads to round-off error. The optimal step size balances these two sources of error.

### Error Analysis

For a function `f` with bounded derivatives, the total error in finite difference approximations consists of:

1. **Truncation Error**: Comes from the finite difference approximation itself
   - Forward differences: `O(h)` where `h` is the step size
   - Central differences: `O(h²)`
   - Hessian central differences: `O(h²)` for second derivatives

2. **Round-off Error**: Comes from floating-point arithmetic
   - Forward differences: `O(eps/h)` where `eps` is machine epsilon
   - Central differences: `O(eps/h)`

### Optimal Step Sizes

Minimizing the total error `truncation + round-off` gives optimal step sizes:

- **Forward differences**: `h* = sqrt(eps)` - balances `O(h)` truncation with `O(eps/h)` round-off
- **Central differences**: `h* = eps^(1/3)` - balances `O(h²)` truncation with `O(eps/h)` round-off
- **Hessian central**: `h* = eps^(1/4)` - balances `O(h²)` truncation for mixed derivatives
- **Complex step**: `h* = eps` - no subtractive cancellation, only limited by machine precision

## Adaptive Step Sizing

The step size computation uses both relative and absolute components:

```julia
epsilon = max(relstep * abs(x), absstep) * dir
```

This ensures:
- **Large values**: Use relative step `relstep * |x|` for scale-invariant accuracy
- **Small values**: Use absolute step `absstep` to avoid underflow
- **Direction**: Multiply by `dir` (±1) for forward differences

## Implementation

The step size computation is handled by internal functions:

- **`compute_epsilon(fdtype, x, relstep, absstep, dir)`**: Computes the actual step size for a given finite difference method and input value
- **`default_relstep(fdtype, T)`**: Returns the optimal relative step size for a given method and numeric type

These functions are called automatically by all finite difference routines, but understanding their behavior can help with custom implementations or debugging numerical issues.

## Special Cases

### Complex Step Differentiation

For complex step differentiation, the step size is simply machine epsilon since this method avoids subtractive cancellation entirely:

⚠️ **Important**: The function `f` must be complex analytic when the input is complex!

### Sparse Jacobians

When computing sparse Jacobians with graph coloring, the step size is computed based on the norm of the perturbation vector to ensure balanced accuracy across all columns in the same color group.

## Practical Considerations

- **Default step sizes** are optimal for most smooth functions
- **Custom step sizes** may be needed for functions with unusual scaling or near-discontinuities
- **Relative steps** should scale with the magnitude of the input
- **Absolute steps** provide a fallback for inputs near zero
- **Direction parameter** allows for one-sided differences when needed (e.g., at domain boundaries)

# Jacobian-Vector Products (JVP)

Functions for computing Jacobian-vector products efficiently without forming the full Jacobian matrix.

## Mathematical Background

The JVP computes `J(x) * v` where `J(x)` is the Jacobian of function `f` at point `x` and `v` is a direction vector. This is computed using finite difference approximations:

- **Forward**: `J(x) * v ≈ (f(x + h*v) - f(x)) / h`  
- **Central**: `J(x) * v ≈ (f(x + h*v) - f(x - h*v)) / (2h)`

where `h` is the step size and `v` is the direction vector.

## Performance Benefits

JVP functions are particularly efficient when you only need directional derivatives:

- **Function evaluations**: Only 2 function evaluations (vs `O(n)` for full Jacobian)
- **Forward differences**: 2 function evaluations, `O(h)` accuracy
- **Central differences**: 2 function evaluations, `O(h²)` accuracy  
- **Memory efficient**: No need to store the full Jacobian matrix

## Use Cases

JVP is particularly useful for:

- **Optimization**: Computing directional derivatives along search directions
- **Sparse directions**: When `v` has few non-zero entries
- **Memory constraints**: Avoiding storage of large Jacobian matrices
- **Newton methods**: Computing Newton steps `J⁻¹ * v` iteratively

## Limitations

- **Complex step**: JVP does not currently support complex step differentiation (`Val(:complex)`)
- **In-place functions**: For in-place function evaluation, ensure proper cache sizing

## Functions

```@docs
FiniteDiff.finite_difference_jvp
FiniteDiff.finite_difference_jvp!
```

## Cache

```@docs
FiniteDiff.JVPCache
```

# Derivatives

Functions for computing derivatives of scalar-valued functions.

## Overview

Derivatives are computed for scalar→scalar maps `f(x)` where `x` can be a single point or a collection of points. The derivative functions support:

- **Forward differences**: `O(1)` function evaluation per point, `O(h)` accuracy
- **Central differences**: `O(2)` function evaluations per point, `O(h²)` accuracy  
- **Complex step**: `O(1)` function evaluation per point, machine precision accuracy

For optimal performance with repeated computations, use the cached versions with `DerivativeCache`.

## Functions

```@docs
FiniteDiff.finite_difference_derivative
FiniteDiff.finite_difference_derivative!
```

## Cache

```@docs
FiniteDiff.DerivativeCache
```

# Hessians

Functions for computing Hessian matrices of scalar-valued functions.

## Function Requirements

Hessian functions are designed for scalar-valued functions `f(x)` where:

- `x` is a vector of parameters
- `f(x)` returns a scalar value
- The Hessian `H[i,j] = ∂²f/(∂x[i]∂x[j])` is automatically symmetrized

## Mathematical Background

For a scalar function `f: ℝⁿ → ℝ`, the Hessian central difference approximation is:

```
H[i,j] ≈ (f(x + eᵢhᵢ + eⱼhⱼ) - f(x + eᵢhᵢ - eⱼhⱼ) - f(x - eᵢhᵢ + eⱼhⱼ) + f(x - eᵢhᵢ - eⱼhⱼ)) / (4hᵢhⱼ)
```

where `eᵢ` is the i-th unit vector and `hᵢ` is the step size in dimension i.

## Performance Considerations

- **Complexity**: Requires `O(n²)` function evaluations for an n-dimensional input
- **Accuracy**: Central differences provide `O(h²)` accuracy for second derivatives  
- **Memory**: The result is returned as a `Symmetric` matrix view
- **Alternative**: For large problems, consider computing the gradient twice instead

## StaticArrays Support

The cache constructor automatically detects `StaticArray` types and adjusts the `inplace` parameter accordingly for optimal performance.

## Functions

```@docs
FiniteDiff.finite_difference_hessian
FiniteDiff.finite_difference_hessian!
```

## Cache

```@docs
FiniteDiff.HessianCache
```

# Tutorials

## Fast Dense Jacobians

It's always fun to start out with a tutorial before jumping into the details!
Suppose we had the functions:

```julia
using FiniteDiff, StaticArrays

fcalls = 0
function f(dx,x) # in-place
    global fcalls += 1
    for i in 2:length(x)-1
        dx[i] = x[i-1] - 2x[i] + x[i+1]
    end
    dx[1] = -2x[1] + x[2]
    dx[end] = x[end-1] - 2x[end]
    nothing
end

const N = 10
handleleft(x,i) = i==1 ? zero(eltype(x)) : x[i-1]
handleright(x,i) = i==length(x) ? zero(eltype(x)) : x[i+1]
function g(x) # out-of-place
    global fcalls += 1
    @SVector [handleleft(x,i) - 2x[i] + handleright(x,i) for i in 1:N]
end
```

and we wanted to calculate the derivatives of them. The simplest thing we can
do is ask for the Jacobian. If we want to allocate the result, we'd use the
allocating function `finite_difference_jacobian` on a 1-argument function `g`:

```julia
x = @SVector rand(N)
FiniteDiff.finite_difference_jacobian(g,x)

#=
10×10 SMatrix{10, 10, Float64, 100} with indices SOneTo(10)×SOneTo(10):
 -2.0   1.0   0.0   0.0   0.0   0.0   0.0   0.0   0.0   0.0
  1.0  -2.0   1.0   0.0   0.0   0.0   0.0   0.0   0.0   0.0
  0.0   1.0  -2.0   1.0   0.0   0.0   0.0   0.0   0.0   0.0
  0.0   0.0   1.0  -2.0   1.0   0.0   0.0   0.0   0.0   0.0
  0.0   0.0   0.0   1.0  -2.0   1.0   0.0   0.0   0.0   0.0
  0.0   0.0   0.0   0.0   1.0  -2.0   1.0   0.0   0.0   0.0
  0.0   0.0   0.0   0.0   0.0   1.0  -2.0   1.0   0.0   0.0
  0.0   0.0   0.0   0.0   0.0   0.0   1.0  -2.0   1.0   0.0
  0.0   0.0   0.0   0.0   0.0   0.0   0.0   1.0  -2.0   1.0
  0.0   0.0   0.0   0.0   0.0   0.0   0.0   0.0   1.0  -2.0
=#
```

FiniteDiff.jl assumes you're a smart cookie, and so if you used an
out-of-place function then it'll not mutate vectors at all, and is thus compatible
with objects like StaticArrays and will give you a fast Jacobian.

But if you wanted to use mutation, then we'd have to use the in-place function
`f` and call the mutating form:

```julia
x = rand(10)
output = zeros(10,10)
FiniteDiff.finite_difference_jacobian!(output,f,x)
output

#=
10×10 Matrix{Float64}:
 -2.0   1.0   0.0   0.0   0.0   0.0   0.0   0.0   0.0   0.0
  1.0  -2.0   1.0   0.0   0.0   0.0   0.0   0.0   0.0   0.0
  0.0   1.0  -2.0   1.0   0.0   0.0   0.0   0.0   0.0   0.0
  0.0   0.0   1.0  -2.0   1.0   0.0   0.0   0.0   0.0   0.0
  0.0   0.0   0.0   1.0  -2.0   1.0   0.0   0.0   0.0   0.0
  0.0   0.0   0.0   0.0   1.0  -2.0   1.0   0.0   0.0   0.0
  0.0   0.0   0.0   0.0   0.0   1.0  -2.0   1.0   0.0   0.0
  0.0   0.0   0.0   0.0   0.0   0.0   1.0  -2.0   1.0   0.0
  0.0   0.0   0.0   0.0   0.0   0.0   0.0   1.0  -2.0   1.0
  0.0   0.0   0.0   0.0   0.0   0.0   0.0   0.0   1.0  -2.0
=#
```

But what if you want this to be completely non-allocating on your mutating form?
Then you need to preallocate a cache:

```julia
cache = FiniteDiff.JacobianCache(x)
```

and now using this cache avoids allocating:

```julia
@time FiniteDiff.finite_difference_jacobian!(output,f,x,cache) # 0.000008 seconds (7 allocations: 224 bytes)
```

And that's pretty much it! Gradients and Hessians work similarly: out of place
doesn't index, and in-place avoids allocations. Either way, you're fast. GPUs
etc. all work.

## Fast Sparse Jacobians

Now let's exploit sparsity. If we knew the sparsity pattern we could write it
down analytically as a sparse matrix, but let's assume we don't. Thus we can
use [SparseConnectivityTracer.jl](https://github.com/adrhill/SparseConnectivityTracer.jl)
to automatically get the sparsity pattern of the Jacobian as a sparse matrix:

```julia
using SparseConnectivityTracer, SparseArrays
in = rand(10)
out = similar(in)

detector = TracerSparsityDetector()
sparsity_pattern = jacobian_sparsity(f,out,in,detector)

sparsejac = Float64.(sparse(sparsity_pattern))
```

Then we can use [SparseMatrixColorings.jl](https://github.com/gdalle/SparseMatrixColorings.jl)
to get the color vector:

```julia
using SparseMatrixColorings
coloring_prob = ColoringProblem(; structure = :nonsymmetric, partition = :column)
coloring_alg = GreedyColoringAlgorithm(; decompression = :direct)
coloring_result = coloring(sparsejac, coloring_prob, coloring_alg)
colors = column_colors(coloring_result)
```

Now we can do sparse differentiation by passing the color vector and the sparsity
pattern:

```julia
sparsecache = FiniteDiff.JacobianCache(x,colorvec=colors,sparsity=sparsejac)
FiniteDiff.finite_difference_jacobian!(sparsejac,f,x,sparsecache)
```

Note that the number of `f` evaluations to fill a Jacobian is `1+maximum(colors)`.
By default, `colors=1:length(x)`, so in this case we went from 10 function calls
to 4. The sparser the matrix, the more the gain! We can measure this as well:

```julia
fcalls = 0
FiniteDiff.finite_difference_jacobian!(output,f,x,cache)
fcalls #11

fcalls = 0
FiniteDiff.finite_difference_jacobian!(sparsejac,f,x,sparsecache)
fcalls #4
```

## Fast Tridiagonal Jacobians

Handling dense matrices? Easy. Handling sparse matrices? Cool stuff. Automatically
specializing on the exact structure of a matrix? Even better. FiniteDiff can
specialize on types which implement the
[ArrayInterfaceCore.jl](https://github.com/JuliaDiffEq/ArrayInterfaceCore.jl) interface.
This includes:

- Diagonal
- Bidiagonal
- UpperTriangular and LowerTriangular
- Tridiagonal and SymTridiagonal
- [BandedMatrices.jl](https://github.com/JuliaMatrices/BandedMatrices.jl)
- [BlockBandedMatrices.jl](https://github.com/JuliaMatrices/BlockBandedMatrices.jl)

Our previous example had a Tridiagonal Jacobian, so let's use this. If we just
do

```julia
using ArrayInterfaceCore, LinearAlgebra
tridiagjac = Tridiagonal(output)
colors = matrix_colors(jac)
```

we get the analytical solution to the optimal matrix colors for our structured
Jacobian. Now we can use this in our differencing routines:

```julia
tridiagcache = FiniteDiff.JacobianCache(x, colorvec=colors, sparsity=tridiagjac)
FiniteDiff.finite_difference_jacobian!(tridiagjac, f, x, tridiagcache)
```

It'll use a special iteration scheme dependent on the matrix type to accelerate
it beyond general sparse usage.

## Fast Block Banded Matrices

Now let's showcase a difficult example. Say we had a large system of partial
differential equations, with a function like:

```julia
function pde(out, x)
    x = reshape(x, 100, 100)
    out = reshape(out, 100, 100)
    m = size(x, 1)
    n = size(x, 2)
    for i in 1:100
        for j in 1:100
            out[i, j] = x[i, j] + x[max(i-1, 1), j] + x[min(i+1, m), j] +  x[i, max(j-1, 1)]  + x[i, min(j+1, n)]
        end
    end
    return vec(out)
end
x = rand(10000)
```

In this case, we can see that our sparsity pattern is a BlockBandedMatrix, so
let's specialize the Jacobian calculation on this fact:

```julia
using FillArrays, BlockBandedMatrices
Jbbb = BandedBlockBandedMatrix(Ones(10000, 10000), fill(100, 100), fill(100, 100), (1, 1), (1, 1))
colorsbbb = ArrayInterfaceCore.matrix_colors(Jbbb)
bbbcache = FiniteDiff.JacobianCache(x,colorvec=colorsbbb,sparsity=Jbbb)
FiniteDiff.finite_difference_jacobian!(Jbbb, pde, x, bbbcache)
```

And boom, a fast Jacobian filling algorithm on your special matrix.

## Reproducibility
```@raw html
<details><summary>The documentation of this SciML package was built using these direct dependencies,</summary>
```
```@example
using Pkg # hide
Pkg.status() # hide
```
```@raw html
</details>
```
```@raw html
<details><summary>and using this machine and Julia version.</summary>
```
```@example
using InteractiveUtils # hide
versioninfo() # hide
```
```@raw html
</details>
```
```@raw html
<details><summary>A more complete overview of all dependencies and their versions is also provided.</summary>
```
```@example
using Pkg # hide
Pkg.status(;mode = PKGMODE_MANIFEST) # hide
```
```@raw html
</details>
```
```@raw html
You can also download the 
<a href="
```
```@eval
using TOML, Markdown
version = TOML.parse(read("../../Project.toml",String))["version"]
name = TOML.parse(read("../../Project.toml",String))["name"]
link = "https://github.com/SciML/"*name*".jl/tree/gh-pages/v"*version*"/assets/Manifest.toml"
Markdown.MD(link)
```
```@raw html
">manifest</a> file and the
<a href="
```
```@eval
using TOML, Markdown
version = TOML.parse(read("../../Project.toml",String))["version"]
name = TOML.parse(read("../../Project.toml",String))["name"]
link = "https://github.com/SciML/"*name*".jl/tree/gh-pages/v"*version*"/assets/Project.toml"
Markdown.MD(link)
```
```@raw html
">project</a> file.
```

# Gradients

Functions for computing gradients of scalar-valued functions with respect to vector inputs.

## Function Types

Gradients support two types of function mappings:

- **Vector→scalar**: `f(x)` where `x` is a vector and `f` returns a scalar
- **Scalar→vector**: `f(fx, x)` for in-place evaluation or `fx = f(x)` for out-of-place

## Performance Notes

- **Forward differences**: `O(n)` function evaluations, `O(h)` accuracy
- **Central differences**: `O(2n)` function evaluations, `O(h²)` accuracy
- **Complex step**: `O(n)` function evaluations, machine precision accuracy

## Cache Management

When using `GradientCache` with pre-computed function values:

- If you provide `fx`, then `fx` will be used in forward differencing to skip a function call
- You must update `cache.fx` before each call to `finite_difference_gradient!`
- For immutable types (scalars, `StaticArray`), use `@set` from [Setfield.jl](https://github.com/jw3126/Setfield.jl)
- Consider aliasing existing arrays into the cache for memory efficiency

## Functions

```@docs
FiniteDiff.finite_difference_gradient
FiniteDiff.finite_difference_gradient!
```

## Cache

```@docs
FiniteDiff.GradientCache
```
